//Ideas
/*
2 Dimensional boolean array to indicate if menu items are disabled
*/

//Menu Bar
  String[] MenusNames ={};
  GButton[] Menus = {};
  int[] MenusWidths = {};
  int[] MenuXpos = {};
  
//Menu Items
  //int for index of opened menu.  -1 if all are closed
    int openedMenu = -1;
  //Menu Item Names
    String[][] MenuItemName = {};
  //Buttons
    GButton[][] MenuItemButtons = {};
  //Radio Buttons
    GOptionGroup[] MenuItemRadioGroups = {};
    GOption[][] MenuItemRadio = {};
  //Checkboxes
    GCheckbox[][] MenuItemCheck = {};

//Activity bar
  GLabel statusBar;
  
void GUIsetup(String renderer){
  //P3D Only
    if(renderer == P3D){
      //Set textmode to SCREEN
      G4P.setTextMode(SCREEN);
      textMode(SCREEN);
    }
  //OPENGL Only
    else{
      
    }
  //Both
    //Look and Feel
      G4P.setColorScheme(this, GCScheme.GREY_SCHEME);
      G4P.setFont(this, "Monaco", 12);
    //Status bar
      statusBar = new GLabel(this, "Hello World", 0, height - 20, width, 20);
    //Menus
      GUIMenuItemSetup();
}

void GUIloop(String renderer){
  //P3D Only
    if(renderer == P3D){
      //Set textmode to SCREEN
        G4P.setTextMode(SCREEN);
        textMode(SCREEN);
      //Opened Menu Background (Boxy)
        if(openedMenu != -1){
          fill(198, 198, 198);
          stroke(99, 99, 99);
          rect(MenuXpos[openedMenu], 22, 128, MenuItemName[openedMenu].length * 21);
        }
    }
  //OPENGL Only
    else{
      //Opened Menu Background (Rounded)
        if(openedMenu != -1){
          fill(198, 198, 198);
          stroke(99, 99, 99);
          rect(MenuXpos[openedMenu], 22, 128, MenuItemName[openedMenu].length * 21 + 4, 0, 0, 8, 8);
        }
    }
  //Both
    //Menu Bar
      fill(198, 198, 198);
      stroke(99, 99, 99);
      rect(0, 0, width, 22);
    //Status Bar
      fill(255,255,255);
      stroke(0, 0, 0);
      statusBar.setText(Minecraft.statusMessage);
      rect(0, height-20, width, 20); 
}

void replaceMenu(int index, String newName, String[] newElements){
  //Change Name
    MenusNames[index] = newName;
  //Dispose Items
    disposeMenuItems(index);
  //Update Items
    MenuItemName[index] = newElements;
    int xTemp = 0;
    for(int i = 0; i<index; i++){
      xTemp = MenusWidths[i];
    }
  //Create Items
    createItems(index, xTemp, MenuItemName[index]);
  //Adjust X of other menus
}

void disposeMenuItems(int index){
  for(int j=0; j<MenuItemName[index].length; j++){
    if(MenuItemName[index][j].charAt(0) == '!'){
      MenuItemButtons[index][j].dispose();
    }
    if(MenuItemName[index][j].charAt(0) == '@'){
      MenuItemRadio[index][j].dispose();
    }
    if(MenuItemName[index][j].charAt(0) == '#'){
      MenuItemCheck[index][j].dispose();
    }
  }
}

void createItems(int index, int xOffset, String items[]){
  //Option group
    MenuItemRadioGroups[index] = new GOptionGroup(this);
  //Y offset for Menu Items
    int yTempItem = 25;
    for(int j=0; j<MenuItemName[index].length; j++){
      String MenuItemNameTemp = items[j].substring(1);
      //Component tagNo X = floor(button.tagNo / MenusNames.length)
      //Component tagNo Y = button.tagNo % MenusNames.length
      //First element of first menu is 0,0
        //Button
          if(MenuItemName[index][j].charAt(0) == '!'){
            //Create button
              MenuItemButtons[index][j] = new GButton(this, MenuItemNameTemp, xOffset, yTempItem, 127, 20);
              MenuItemButtons[index][j].tag = MenuItemNameTemp;
              MenuItemButtons[index][j].tagNo = index * MenusNames.length + j;
              MenuItemButtons[index][j].setTextAlign(GAlign.LEFT | GAlign.TOP);
            //Disable button
              MenuItemButtons[index][j].setVisible(false);
              MenuItemButtons[index][j].setEnabled(false);
          }
        //Radio Button
          if(MenuItemName[index][j].charAt(0) == '@'){
            //Create radio button
              MenuItemRadio[index][j] = new GOption(this, MenuItemNameTemp, xOffset + 1, yTempItem, 127);
              MenuItemRadio[index][j].tag = MenuItemNameTemp;
              MenuItemRadio[index][j].tagNo = index * MenusNames.length + j;
              MenuItemRadio[index][j].setTextAlign(GAlign.LEFT | GAlign.TOP);
              MenuItemRadioGroups[index].addOption(j, MenuItemRadio[index][j]);
            //Disable button
              MenuItemRadio[index][j].setVisible(false);
              MenuItemRadio[index][j].setEnabled(false);
          }
        //Checkbox
          if(MenuItemName[index][j].charAt(0) == '#'){
            //Create checkbox
              MenuItemCheck[index][j] = new GCheckbox(this, MenuItemNameTemp, xOffset + 3, yTempItem, 127);
              MenuItemCheck[index][j].tag = MenuItemNameTemp;
              MenuItemCheck[index][j].tagNo = index * MenusNames.length + j;
              MenuItemCheck[index][j].setTextAlign(GAlign.LEFT | GAlign.TOP);
            //Disable checkbox
              MenuItemCheck[index][j].setVisible(false);
              MenuItemCheck[index][j].setEnabled(false);
          }
        yTempItem = yTempItem + 21;
    }
}

void replaceGUI(String[] newMenuBar, GButton[] newMenus, String[][] newElements, GButton[][] newButtons, GOptionGroup[] newRadioGroups, GOption[][] newRadios, GCheckbox[][] newChecks){
  //Dispose Menu Bar
    for(int i=0; i<MenuItemName.length; i++){
      Menus[i].dispose();
    }
  //Disposes all elements of every dropdown menu and replaces them with new Elements
  //Dispose all items
    for(int i=0; i<MenuItemName.length; i++){
      disposeMenuItems(i);
    }
  //Update items
    //Menu Bar
      MenusNames = newMenuBar;
      Menus = newMenus;
    //Menu Item Names
      MenuItemName = newElements;
    //Buttons
      MenuItemButtons = newButtons;
    //Radio Buttons
      MenuItemRadioGroups = newRadioGroups;
      MenuItemRadio = newRadios;
    //Checkboxes
      MenuItemCheck = newChecks;
  //Component Creation
    //Menu Bar
      //X offset for Menu Bar
        int xTemp = 1;
        MenuXpos = new int[MenusNames.length];
        MenusWidths = new int[MenusNames.length];
        for(int i=0; i<Menus.length; i++){
          //tagNo is the index -1 to prevent interference with Menu Items
          //First menu tagNo is -1
            //Widths
              MenusWidths[i] = MenusNames[i].length() * 7 + 12;
            //X positions
              if(i == 0){
                //First Menu
                  MenuXpos[i] = 1;
              }
              else{
                //Next menus
                  MenuXpos[i] = MenuXpos[i-1] + MenusWidths[i-1] + 1;
              }
            Menus[i] = new GButton(this, MenusNames[i], MenuXpos[i], 1, MenusWidths[i], 20);
            Menus[i].tagNo = i * -1 -1;
            Menus[i].setTextAlign(GAlign.LEFT | GAlign.TOP);
          //Change xTemp for next menu
            xTemp = xTemp + MenusWidths[i] + 1;
        }
      //Menu Items
        //X offset for menu Items
          int xTempItem = 1;
          for(int i=0; i<Menus.length; i++){
            createItems(i, xTempItem, MenuItemName[i]);
            //Change xTemp for next menu
              xTempItem = xTempItem + MenusWidths[i] + 1;
          }
      //Default settings on startup
        //Both
          //Show
            for(int i=0; i<MenuItemCheck[2].length; i++){
              MenuItemCheck[2][i].setSelected(true);
            }
            for(int i=0; i< PonyBase.show.length; i++){
              PonyBase.show[i] = true;
            }
            for(int i=0; i< Human.show.length; i++){
              Human.show[i] = true;
            }
          //Lights
            MenuItemCheck[4][2].setSelected(true);
       //Pony
         if(PonyBase.race != 0){
           //Center on Body
             MenuItemRadioGroups[1].setSelected(4);
         }
       //Human
         else{
           //Center on Body
             MenuItemRadioGroups[1].setSelected(1);
         }
}

void GUIMenuItemSetup(){
  PonyBase.specialScan(Minecraft);
  //Check for pony skin
    if(PonyBase.race != 0){
      //Change to Pony GUI
        replaceGUI(PonyBase.MenuBar, PonyBase.Menus, PonyBase.GUIMenuItemNames, PonyBase.GUIButtons, PonyBase.GUIRadioGroups, PonyBase.GUIRadios, PonyBase.GUIChecks);
      //Set Pose
        MenuItemRadioGroups[3].setSelected(0);
      //Set race
        MenuItemRadioGroups[5].setSelected(PonyBase.race-1);
      //Set tailLength
        MenuItemRadioGroups[6].setSelected(PonyBase.tailLength);
      //Set Gender
        if(PonyBase.male == 1){
          MenuItemCheck[5][5].setSelected(true);
        }
      //Set pony size
        switch(PonyBase.ponySize){
          case 0:
            MenuItemRadioGroups[7].setSelected(0);
            break;
          case 1:
            MenuItemRadioGroups[7].setSelected(1);
            break;
          case 2:
            MenuItemRadioGroups[7].setSelected(2);
            break;
          case 3:
            MenuItemRadioGroups[7].setSelected(3);
            break;
          default:
            break;
        }
    }
    else{
      //Change to Human GUI
        replaceGUI(Human.MenuBar, Human.Menus, Human.GUIMenuItemNames, Human.GUIButtons, Human.GUIRadioGroups, Human.GUIRadios, Human.GUIChecks);
        MenuItemRadioGroups[5].setSelected(4);
    }
}
