class MCPonyBase{
  //Observations on different sizes based on screenshots
/*Pixel Size    Head    Body   Legs
  Normal(unit)  8x8     8x8    8x8
  Foal          6x6     4x4    4x4
  Large         8x8     10x10  10x10
  Alicorn       8x8     8x10   
  
  Trial 1 Front
             Head     Leg(BCRGBCYM)  Horn Width
  Normal     44x44    40x40          6
  Foal       40x40    26x18          6
  Large      44x44    48x48          6
  Alicorn    44x44    40x46          6
  
  
  Trial 2 Back
             Head     Leg(BCRGBCYM)  Flank
  Normal     42x42    48x48          50x50
  Foal       38x38    26x18          28x28
  Large      42x42    58x56          60x64
  Alicorn    42x42    48x56          50x50
 
*/
  MinecraftSkin Minecraft;

  //Special Features
    int race;
      //1: Earth Pony
      final color raceEarthColor = color(249, 177, 49, 255);
      //2: Pegasus
      final color racePegasusColor = color(136, 202, 240, 255);
      //3: Unicorn
      final color raceUnicornColor = color(209, 159, 228, 255);
      //4: Alicorn
      final color raceAlicornColor = color(254, 249, 252, 255);
      //0:  Default Human color(0, 0, 0, 0)
    int tailLength;
      //0: Stub
      final color tail0Color = color(66, 88, 68, 255);
      //1: 1/4
      final color tail1Color = color(70, 142, 136, 255);
      //2: 2/4
      final color tail2Color = color(83, 75, 118, 255);
      //3: 3/4
      final color tail3Color = color(138, 107, 127, 255);
      //0:  Default Full color(0, 0, 0, 0)
    int male;
      //1: Male
      final color maleColor = color(255, 255, 255, 255);
      //0: Default Female color(0, 0, 0, 0)
    int ponySize;
      //1: Foal
      final color sizeFoalColor = color(255, 190, 83, 255);
      //2: Large
      final color sizeLargeColor = color(206, 50, 84, 255);
      //3: Alicorn
      final color sizeAlicornColor = color(42, 60, 120, 255);
      //0:  Normal Full color(0, 0, 0, 0)
      
  //Viewing Options
    int pose;
    boolean[] show = {true,true,true,true,true,true,true,true,true,true,true,true,true,true,true};
    //boolean[] grid = {false,false,false,false,false,false,false,false,false,false,false,false,false};
    boolean grid = false;
    
  //GUI Elements
    //Menu Bar
      final String[] MenuBar = {"File","Center","Show/Hide","Pose","Special","Kind","Tail","Size"};
      final int indexFile = 0;
      final int indexCenter = 1;
      final int indexShow = 2;
      final int indexPose = 3;
      final int indexSpecial = 4;
      final int indexKind = 5;
      final int indexTail = 6;
      final int indexSize = 7;
      GButton[] Menus = new GButton[MenuBar.length];
    //Menu Items
      final String[][] GUIMenuItemNames = { {"!Open","!Save","!Save as","!Load","#Auto-Load"},
                                            {"@Head","@Ears","@Snuzzle","@Neck","@Body","@Left Fore Leg","@Right Fore Leg","@Left Hind Leg","@Right Hind Leg","@Tail 1","@Tail 2","@Mane","@Left Wing","@Right Wing","@Horn"},
                                            {"#Head","#Ears","#Snuzzle","#Neck","#Body","#Left Fore Leg","#Right Fore Leg","#Left Hind Leg","#Right Hind Leg","#Tail 1","#Tail 2","#Mane","#Left Wing","#Right Wing","#Horn"},
                                            {"@Normal","@Sleeping","@Sneaking","@Flying","@Magic Spell"},
                                            {"#Grid","#Smoothing","#Lights","!Fix Alpha","!Fix Black"},
                                            {"@Earth Pony","@Pegasus","@Unicorn","@Alicorn","@Human","#Male"},
                                            {"@Stub","@1/4","@2/4","@3/4","@Full"},
                                            {"@Normal","@Foal","@Large","@Alicorn"}
                                          };
      //Buttons
        final GButton[][] GUIButtons = { new GButton[GUIMenuItemNames[0].length],
                                         new GButton[GUIMenuItemNames[1].length],
                                         new GButton[GUIMenuItemNames[2].length],
                                         new GButton[GUIMenuItemNames[3].length],
                                         new GButton[GUIMenuItemNames[4].length],
                                         new GButton[GUIMenuItemNames[5].length],
                                         new GButton[GUIMenuItemNames[6].length],
                                         new GButton[GUIMenuItemNames[7].length]
                                       };
                                      
      //Checkboxes
        final GCheckbox[][] GUIChecks = { new GCheckbox[GUIMenuItemNames[0].length],
                                          new GCheckbox[GUIMenuItemNames[1].length],
                                          new GCheckbox[GUIMenuItemNames[2].length],
                                          new GCheckbox[GUIMenuItemNames[3].length],
                                          new GCheckbox[GUIMenuItemNames[4].length],
                                          new GCheckbox[GUIMenuItemNames[5].length],
                                          new GCheckbox[GUIMenuItemNames[6].length],
                                          new GCheckbox[GUIMenuItemNames[7].length]
                                        };
      //Radio Buttons
        final GOptionGroup[] GUIRadioGroups = new GOptionGroup[GUIMenuItemNames.length];
        final GOption[][] GUIRadios = { new GOption[GUIMenuItemNames[0].length],
                                        new GOption[GUIMenuItemNames[1].length],
                                        new GOption[GUIMenuItemNames[2].length],
                                        new GOption[GUIMenuItemNames[3].length],
                                        new GOption[GUIMenuItemNames[4].length],
                                        new GOption[GUIMenuItemNames[5].length],
                                        new GOption[GUIMenuItemNames[6].length],
                                        new GOption[GUIMenuItemNames[7].length]
                                      };
  //
  MCPonyBase(MinecraftSkin skin){
    Minecraft = skin;
  }
  
  void update(MinecraftSkin skin){
    Minecraft.revertSkin();
    Minecraft = skin;
  }
  
  void drawPony(int ponySize){
    switch(ponySize){
      case 0:
        NormalPony.drawPony();
        break;
      case 1:
        SmallPony.drawPony();
        break;
      case 2:
        LargePony.drawPony();
        break;
      case 3:
        PrincessPony.drawPony();
        break;
    }
  }
  
  //Detect Special features
   void specialScan(MinecraftSkin Skin) {
      //Kind
        switch(Skin.loadedImage.pixels[0]){
          case -413391:
            race = 1;
            //println("Race: Earth Pony");
            break;
          case -7812368:
            race = 2;
            //println("Race: Pegasus");
            break;
          case -3039260:
            race = 3;
            //println("Race: Unicorn");
            break;
          case -67076:
            race = 4;
            //println("Race: Alicorn");
            break;
          default:
            race = 0;
            //println("Non-pony skin detected, race set to: Human");
        }
      //Tail
        switch(Skin.loadedImage.pixels[1]){
          case -12429244:
            tailLength = 0;
            //println("Tail Length: Stub");
            break;
          case -12153208:
            tailLength = 1;
            //println("Tail Length: 1/4");
            break;
          case -11318410:
            tailLength = 2;
            //println("Tail Length: 2/4");
            break;
          case -7705729:
            tailLength = 3;
            //println("Tail Length: 3/4");
            break;
          default:
            tailLength = 4;
            //println("Tail Length: Full");
        }
      //Gender
        switch(Skin.loadedImage.pixels[2]){
          case -1:
            male = 1;
            //println("Gender: Male");
            break;
          default:
            male = 0;
            //println("Gender: Female");
        }
      //Size
        switch(int(Skin.loadedImage.pixels[3])){
          case -16813:
            ponySize = 1;
            //println("Size: Foal");
            break;
          case -3263916:
            ponySize = 2;
            //println("Size: Large");
            break;
          case -14009224:
            ponySize = 3;
            //println("Size: Alicorn");
            break;
          default:
            ponySize = 0;
            //println("Size: Normal");
        }
    }
  //Change special features
    void specialUpdate() {
      //Kind
        switch(PonyBase.race) {
          //Earth Pony
            case 1:
              Minecraft.loadedImage.pixels[0] = raceEarthColor;
              break;
          //Pegasus
            case 2:
              Minecraft.loadedImage.pixels[0] = racePegasusColor;
              break;
          //Unicorn
            case 3:
              Minecraft.loadedImage.pixels[0] = raceUnicornColor;
              break;
          //Alicorn
            case 4:
              Minecraft.loadedImage.pixels[0] = raceAlicornColor;
              break;
          //Error
            default:
              Minecraft.loadedImage.pixels[0] = color(0, 0, 0, 0);
        }
      //Tail
        switch(PonyBase.tailLength) {
          //  Stub
            case 0:
              Minecraft.loadedImage.pixels[1] = tail0Color;
              break;
          //  1/4
            case 1:
              Minecraft.loadedImage.pixels[1] = tail1Color;
              break;
          //  2/4
            case 2:
              Minecraft.loadedImage.pixels[1] = tail2Color;
              break;
          //  3/4
            case 3:
              Minecraft.loadedImage.pixels[1] = tail3Color;
              break;
          //  Full
            default:
              Minecraft.loadedImage.pixels[1] = color(0, 0, 0, 0);
        }
      //Gender
        if (PonyBase.male == 1) {
          Minecraft.loadedImage.pixels[2] = maleColor;
        }
        else {
          Minecraft.loadedImage.pixels[2] = color(0, 0, 0, 0);
        }
      //Size
        switch(PonyBase.ponySize){
          //Foal
            case 1:
              Minecraft.loadedImage.pixels[3] = sizeFoalColor;
              break;
          //Large
            case 2:
              Minecraft.loadedImage.pixels[3] = sizeLargeColor;
              break;
          //Alicorn
            case 3:
              Minecraft.loadedImage.pixels[3] = sizeAlicornColor;
              break;
          //Normal
            default:
              Minecraft.loadedImage.pixels[3] = color(0, 0, 0, 0);
        }
    }
}
