import processing.core.*; 
import processing.xml.*; 

import guicomponents.*; 
import processing.opengl.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class My_Little_Skin extends PApplet {

//Use screenX and screenY for direct model painting
//Add check for .png files to MinecraftSkin class
//Implement GUI

//Objects
  MinecraftSkin Minecraft = new MinecraftSkin();
  MCPonyBase PonyBase = new MCPonyBase();
  
  MCPonyNormal NormalPony = new MCPonyNormal(Minecraft, PonyBase);
  MCPonyFoal SmallPony = new MCPonyFoal(Minecraft, PonyBase);
  MCPonyLarge LargePony = new MCPonyLarge(Minecraft, PonyBase);
  MCPonyAlicorn PrincessPony = new MCPonyAlicorn(Minecraft, PonyBase);
  MCHuman Human = new MCHuman(Minecraft);
//Model direction variables
  int directionY = 60;
  int directionX = 210;

//Libraries
/*
http://www.lagers.org.uk/g4p/
http://www.lagers.org.uk/g4p/distribution/web/reference/guicomponents/GComponent.html
/*/
//GUI library

//OPENGL Can be removed if using P3D to save space

//Set to renderer
String renderer = P3D;
public void setup(){
  size(800,600,renderer);
  GUIsetup(renderer);
}

public void draw(){
  background(255, 255, 255);
  //Draw preview
    //2D
//      noStroke();
//      for(int i=0; i<64; i++){
//        for(int j=0; j<32; j++){
//          fill(128, 128, 128);
//          rect(16*i+20, 16*j+height-276, 16, 16);
//          fill(red(Minecraft.loadedImage.pixels[i+j*64]),green(Minecraft.loadedImage.pixels[i+j*64]),blue(Minecraft.loadedImage.pixels[i+j*64]),alpha(Minecraft.loadedImage.pixels[i+j*64]));
//          rect(16*i+20, 16*j+height-276, 16, 16);
//        }
//      }
    //3D
    //Rotate with mouse movement
      if(leftDown){
        directionX = directionX + mouseDX();
        directionY = directionY + mouseDY();
      }
    //println(mouseX+","+mouseY);
    pushMatrix();
      noSmooth();
      if(MenuItemCheck[4][1].isSelected()){
        smooth();
      }
      noLights();
      if(MenuItemCheck[4][2].isSelected()){
        lights();
      }
      translate(width/2, height/2, 0);
      rotateX(radians(directionY));
      rotateZ(radians(directionX));
        noStroke();
        if(!MenuItemRadio[5][4].isSelected()){
          if(MenuItemRadio[7][0].isSelected()){
            NormalPony.drawPony();
          }
          if(MenuItemRadio[7][1].isSelected()){
            SmallPony.drawPony();
          }
          if(MenuItemRadio[7][2].isSelected()){
            LargePony.drawPony();
          }
          if(MenuItemRadio[7][3].isSelected()){
            PrincessPony.drawPony();
          }
        }
        else{
          Human.drawHuman();
        }
    popMatrix();
    smooth();
    noLights();
    strokeWeight(1);
  GUIloop(renderer);
}
class GUI {
  GUI(){
    
  }
}
//Ideas
/*
2 Dimensional boolean array to indicate if menu items are disabled
*/

//Menu Bar
  String[] MenusNames;
  GButton[] Menus;
  
  int[] MenusWidths;
  
//Menu Items
  //int for index of opened menu.  -1 if all are closed
    int openedMenu = -1;
  //Menu Item Names
    String[][] MenuItemName;
  //Buttons
    GButton[][] MenuItemButtons;
  //Radio Buttons
    GOptionGroup[] MenuItemRadioGroups;
    GOption[][] MenuItemRadio;
  //Checkboxes
    GCheckbox[][] MenuItemCheck;

public void GUIsetup(String renderer){
  //P3D Only
    if(renderer == P3D){
      //SEt textmode to SCREEN
      G4P.setTextMode(SCREEN);
      textMode(SCREEN);
    }
  //OPENGL Only
    else{
      
    }
  //Both
    //Look and Feel
      G4P.setColorScheme(this, GCScheme.GREY_SCHEME);
      G4P.setFont(this, "Monaco", 12);
      //Menu Bar
        MenusNames = PonyBase.MenuBar;
        Menus = PonyBase.Menus;
      //Menu Item Names
        MenuItemName = PonyBase.GUIMenuItemNames;
      //Buttons
        MenuItemButtons = PonyBase.GUIButtons;
      //Radio Buttons
        MenuItemRadioGroups = PonyBase.GUIRadioGroups;
        MenuItemRadio = PonyBase.GUIRadios;
      //Checkboxes
        MenuItemCheck = PonyBase.GUIChecks;
        
    //Component Creation
      //X offset for Menu Bar
        int xTemp = 1;
      //X offset for menu Items
        int xTempItem = 1;
        MenusWidths = new int[MenusNames.length];
        for(int i=0; i<Menus.length; i++){
          //Menu Bar
          //tagNo is the index -1 to prevent interference with Menu Items
          //First menu tagNo is -1
            MenusWidths[i] = MenusNames[i].length() * 7 + 12;
            Menus[i] = new GButton(this, MenusNames[i], xTemp, 1, MenusWidths[i], 20);
            Menus[i].tagNo = i * -1 -1;
            Menus[i].setTextAlign(GAlign.LEFT | GAlign.TOP);
          //X offset for menu items 
            xTemp = xTemp + MenusWidths[i] + 1;
        }
      //Menu Items
        for(int i=0; i<Menus.length; i++){
          //Component Creation
            //Option Groups
              MenuItemRadioGroups[i] = new GOptionGroup(this);
            //Menu Items
              //Y offset for Menu Items
                int yTempItem = 22;
                for(int j=0; j<MenuItemName[i].length; j++){
                  String MenuItemNameTemp = MenuItemName[i][j].substring(1);
                  //Component tagNo X = floor(button.tagNo / MenusNames.length)
                  //Component tagNo Y = button.tagNo % MenusNames.length
                  //First element of first menu is 0,0
                    //Button
                      if(MenuItemName[i][j].charAt(0) == '!'){
                        //Create button
                          MenuItemButtons[i][j] = new GButton(this, MenuItemNameTemp, xTempItem, yTempItem, 127, 20);
                          MenuItemButtons[i][j].tag = MenuItemNameTemp;
                          MenuItemButtons[i][j].tagNo = i * MenusNames.length + j;
                          MenuItemButtons[i][j].setTextAlign(GAlign.LEFT | GAlign.TOP);
                        //Disable button
                          MenuItemButtons[i][j].setVisible(false);
                          MenuItemButtons[i][j].setEnabled(false);
                      }
                    //Radio Button
                      if(MenuItemName[i][j].charAt(0) == '@'){
                        //Create radio button
                          MenuItemRadio[i][j] = new GOption(this, MenuItemNameTemp, xTempItem, yTempItem, 127);
                          MenuItemRadio[i][j].tag = MenuItemNameTemp;
                          MenuItemRadio[i][j].tagNo = i * MenusNames.length + j;
                          MenuItemRadio[i][j].setTextAlign(GAlign.LEFT | GAlign.TOP);
                          MenuItemRadioGroups[i].addOption(j, MenuItemRadio[i][j]);
                        //Disable button
                          MenuItemRadio[i][j].setVisible(false);
                          MenuItemRadio[i][j].setEnabled(false);
                      }
                    //Checkbox
                      if(MenuItemName[i][j].charAt(0) == '#'){
                        //Create checkbox
                          MenuItemCheck[i][j] = new GCheckbox(this, MenuItemNameTemp, xTempItem, yTempItem, 127);
                          MenuItemCheck[i][j].tag = MenuItemNameTemp;
                          MenuItemCheck[i][j].tagNo = i * MenusNames.length + j;
                          MenuItemCheck[i][j].setTextAlign(GAlign.LEFT | GAlign.TOP);
                        //Disable checkbox
                          MenuItemCheck[i][j].setVisible(false);
                          MenuItemCheck[i][j].setEnabled(false);
                      }
                    yTempItem = yTempItem + 21;
                }
                xTempItem = xTempItem + MenusWidths[i] + 1;
        }
        
        GUIMenuItemSetup();
}

public void GUIloop(String renderer){
  //Both
    fill(198,198,198);
    stroke(99,99,99);
    rect(0,0,width,21);
  //P3D Only
    if(renderer == P3D){
      
    }
  //OPENGL Only
    else{
      
    }
  //Both
}

public void replaceGUI(String[] newMenuBar, GButton[] newMenus, String[][] newElements, GButton[][] newButtons, GOptionGroup[] newRadioGroups, GOption[][] newRadios, GCheckbox[][] newChecks){
  //Dispose Menu Bar
  for(int i=0; i<MenuItemName.length; i++){
    Menus[i].dispose();
  }
  //Disposes all elements of every dropdown menu and replaces them with new Elements
  //Dispose all items
  for(int i=0; i<MenuItemName.length; i++){
    for(int j=0; j<MenuItemName[i].length; j++){
      if(MenuItemName[i][j].charAt(0) == '!'){
        MenuItemButtons[i][j].dispose();
      }
      if(MenuItemName[i][j].charAt(0) == '@'){
        MenuItemRadio[i][j].dispose();
      }
      if(MenuItemName[i][j].charAt(0) == '#'){
        MenuItemCheck[i][j].dispose();
      }
    }
  }
  //Menu Bar
    MenusNames = newMenuBar;
    Menus = newMenus;
  //Menu Item Names
    MenuItemName = newElements;
  //Buttons
    MenuItemButtons = newButtons;
  //Radio Buttons
    MenuItemRadioGroups = newRadioGroups;
    MenuItemRadio = newRadios;
  //Checkboxes
    MenuItemCheck = newChecks;
  //Component Creation
      //X offset for Menu Bar
        int xTemp = 1;
      //X offset for menu Items
        int xTempItem = 1;
        MenusWidths = new int[MenusNames.length];
        for(int i=0; i<Menus.length; i++){
          //Menu Bar
          //tagNo is the index -1 to prevent interference with Menu Items
          //First menu tagNo is -1
            MenusWidths[i] = MenusNames[i].length() * 7 + 12;
            Menus[i] = new GButton(this, MenusNames[i], xTemp, 1, MenusWidths[i], 20);
            Menus[i].tagNo = i * -1 -1;
            Menus[i].setTextAlign(GAlign.LEFT | GAlign.TOP);
          //X offset for menu items 
            xTemp = xTemp + MenusWidths[i] + 1;
        }
      //Menu Items
        for(int i=0; i<Menus.length; i++){
          //Component Creation
            //Option Groups
              MenuItemRadioGroups[i] = new GOptionGroup(this);
            //Menu Items
              //Y offset for Menu Items
                int yTempItem = 22;
                for(int j=0; j<MenuItemName[i].length; j++){
                  String MenuItemNameTemp = MenuItemName[i][j].substring(1);
                  //Component tagNo X = floor(button.tagNo / MenusNames.length)
                  //Component tagNo Y = button.tagNo % MenusNames.length
                  //First element of first menu is 0,0
                    //Button
                      if(MenuItemName[i][j].charAt(0) == '!'){
                        //Create button
                          MenuItemButtons[i][j] = new GButton(this, MenuItemNameTemp, xTempItem, yTempItem, 127, 20);
                          MenuItemButtons[i][j].tag = MenuItemNameTemp;
                          MenuItemButtons[i][j].tagNo = i * MenusNames.length + j;
                          MenuItemButtons[i][j].setTextAlign(GAlign.LEFT | GAlign.TOP);
                        //Disable button
                          MenuItemButtons[i][j].setVisible(false);
                          MenuItemButtons[i][j].setEnabled(false);
                      }
                    //Radio Button
                      if(MenuItemName[i][j].charAt(0) == '@'){
                        //Create radio button
                          MenuItemRadio[i][j] = new GOption(this, MenuItemNameTemp, xTempItem, yTempItem, 127);
                          MenuItemRadio[i][j].tag = MenuItemNameTemp;
                          MenuItemRadio[i][j].tagNo = i * MenusNames.length + j;
                          MenuItemRadio[i][j].setTextAlign(GAlign.LEFT | GAlign.TOP);
                          MenuItemRadioGroups[i].addOption(j, MenuItemRadio[i][j]);
                        //Disable button
                          MenuItemRadio[i][j].setVisible(false);
                          MenuItemRadio[i][j].setEnabled(false);
                      }
                    //Checkbox
                      if(MenuItemName[i][j].charAt(0) == '#'){
                        //Create checkbox
                          MenuItemCheck[i][j] = new GCheckbox(this, MenuItemNameTemp, xTempItem, yTempItem, 127);
                          MenuItemCheck[i][j].tag = MenuItemNameTemp;
                          MenuItemCheck[i][j].tagNo = i * MenusNames.length + j;
                          MenuItemCheck[i][j].setTextAlign(GAlign.LEFT | GAlign.TOP);
                        //Disable checkbox
                          MenuItemCheck[i][j].setVisible(false);
                          MenuItemCheck[i][j].setEnabled(false);
                      }
                    yTempItem = yTempItem + 21;
                }
                xTempItem = xTempItem + MenusWidths[i] + 1;
        }
      //Default settings on startup
        //Show
          for(int i=0; i<MenuItemCheck[1].length; i++){
            MenuItemCheck[1][i].setSelected(true);
            //MenuItemCheck[2][i].setSelected(false);
          }
        //Lights
          MenuItemCheck[4][2].setSelected(true);
}

public void GUIMenuItemSetup(){
  PonyBase.specialScan(Minecraft);
  //Check for pony skin
    if(PonyBase.race != 0){
      //Change to Pony GUI
        replaceGUI(PonyBase.MenuBar, PonyBase.Menus, PonyBase.GUIMenuItemNames, PonyBase.GUIButtons, PonyBase.GUIRadioGroups, PonyBase.GUIRadios, PonyBase.GUIChecks);
      //Set Pose
        MenuItemRadioGroups[3].setSelected(0);
      //Set race
        MenuItemRadioGroups[5].setSelected(PonyBase.race-1);
      //Set tailLength
        MenuItemRadioGroups[6].setSelected(PonyBase.tailLength);
      //Set Gender
        if(PonyBase.male == 1){
          MenuItemCheck[5][5].setSelected(true);
        }
      //Set pony size
        switch(PonyBase.ponySize){
          case 0:
            MenuItemRadioGroups[7].setSelected(0);
            break;
          case 1:
            MenuItemRadioGroups[7].setSelected(1);
            break;
          case 2:
            MenuItemRadioGroups[7].setSelected(2);
            break;
          case 3:
            MenuItemRadioGroups[7].setSelected(3);
            break;
          default:
            break;
        }
    }
    else{
      //Change to Human GUI
        replaceGUI(Human.MenuBar, Human.Menus, Human.GUIMenuItemNames, Human.GUIButtons, Human.GUIRadioGroups, Human.GUIRadios, Human.GUIChecks);
        MenuItemRadioGroups[5].setSelected(4);
    }
}
public void handleButtonEvents(GButton button){
  //Open or Change Menu
    if(button.tagNo < 0){
      //Close all Menus
        dropdownClose(-1);
      //Close menu it it was already opened
        if(openedMenu == button.tagNo * -1 -1){
          dropdownClose(button.tagNo * -1 -1);
          openedMenu = -1;
        }
        else{
          dropdownOpen(button.tagNo * -1 -1);
          openedMenu = button.tagNo * -1 -1;
          println(button.tagNo);
        }
    }
  //Menu Item
    else{
      for(int i=0; i<Menus.length-1; i++){
        Menus[i].draw();
      }
      
      switch(floor(button.tagNo/MenusNames.length)){
        //File
          case 0:
            switch(button.tagNo % MenusNames.length){
              //Open
                case 0:
                  Minecraft.selectOpenSkin();
                  GUIMenuItemSetup();
                  break;
              //Save
                case 1:
                  Minecraft.saveDir();
                  break;
              //Save As
                case 2:
                  Minecraft.selectSave();
                  break;
              //Load
                case 3:
                  Minecraft.revert();
                  break;
              //default
                default:
            }
          break;
        //Special
          case 4:
            switch(button.tagNo % MenusNames.length){
              //Fix Alpha
                case 3:
                  Minecraft.quickfix();
                  println("Alpha");
                  break;
              //Fix Black
                case 4:
                  Minecraft.quickfix2();
                  println("Black");
                  break;
              //default
                default:
            }
          break;
        default:
      }
      println(floor(button.tagNo / MenusNames.length) + "," + button.tagNo % MenusNames.length);
    }
}

public void dropdownClose(int number){
  //Hides and disables all dropdown menus of index number
  //Closes all dropdown menus if number == -1
  int iStart = 0;
  int iEnd = Menus.length;
  if(number != -1){
    iStart = number;
    iEnd = number+1;
  }
  println(iStart);
  for(int i=iStart; i<iEnd; i++){
    for(int j=0; j<MenuItemName[i].length; j++){
      if(MenuItemName[i][j].charAt(0) == '!'){
        MenuItemButtons[i][j].setVisible(false);
        MenuItemButtons[i][j].setEnabled(false);
      }
      if(MenuItemName[i][j].charAt(0) == '@'){
        MenuItemRadio[i][j].setVisible(false);
        MenuItemRadio[i][j].setEnabled(false);
      }
      if(MenuItemName[i][j].charAt(0) == '#'){
        MenuItemCheck[i][j].setVisible(false);
        MenuItemCheck[i][j].setEnabled(false);
      }
    }
  }
}

public void dropdownOpen(int number){
  //Shows and enables all dropdown menus of index number
  //Opens all dropdown menus if number == -1
  int iStart = 0;
  int iEnd = Menus.length;
  if(number != -1){
    iStart = number;
    iEnd = number+1;
  }
  println(iStart);
  for(int i=iStart; i<iEnd; i++){
    for(int j=0; j<MenuItemName[i].length; j++){
      if(MenuItemName[i][j].charAt(0) == '!'){
        MenuItemButtons[i][j].setVisible(true);
        MenuItemButtons[i][j].setEnabled(true);
      }
      if(MenuItemName[i][j].charAt(0) == '@'){
        MenuItemRadio[i][j].setVisible(true);
        MenuItemRadio[i][j].setEnabled(true);
      }
      if(MenuItemName[i][j].charAt(0) == '#'){
        MenuItemCheck[i][j].setVisible(true);
        MenuItemCheck[i][j].setEnabled(true);
      }
    }
  }
}
public void handleCheckboxEvents(GCheckbox checkbox){
  //Unused
    if(checkbox.tagNo < 0){

    }
  //Checkboxes
    else{
      //Hide/Show
        for(int i=0; i<MenuItemCheck[1].length; i++){
          PonyBase.show[i] = MenuItemCheck[1][i].isSelected();
        }
      //Grid;
//        for(int i=0; i<MenuItemCheck[2].length; i++){
//          PonyBase.grid[i] = MenuItemCheck[2][i].isSelected();
//        }
      //Special
        //Grid
          PonyBase.grid = false;
          if(MenuItemCheck[4][0].isSelected()){
            PonyBase.grid = true;
          }
        //Smoothing
          //See draw()
        //Lights
          //See draw()
      //Kind
        //male
          if(MenuItemCheck[5][5].isSelected()){
            PonyBase.male = 1;
            PonyBase.specialUpdate();
          }
          else{
            PonyBase.male = 0;
            PonyBase.specialUpdate();
          }
    }
  println(floor(checkbox.tagNo / MenusNames.length) + "," + checkbox.tagNo % MenusNames.length);
}
public void handleOptionEvents(GOption selected, GOption deselected){
  //Unused
    if(selected.tagNo < 0){

    }
  //Checkboxes
    else{
      switch(floor(selected.tagNo/MenusNames.length)){
          case 3:
            //Pose
              GUIMenuItemSetup();
              break;
          case 5:
            //Kind
              if(floor(selected.tagNo % MenusNames.length) == 4){
                //Human
                  PonyBase.race = 0;
              }
              else{
                //Pony
                  PonyBase.race = floor(selected.tagNo % MenusNames.length)+1;
              }
              replaceGUI(Human.MenuBar, Human.Menus, Human.GUIMenuItemNames, Human.GUIButtons, Human.GUIRadioGroups, Human.GUIRadios, Human.GUIChecks);
              PonyBase.specialUpdate();
              GUIMenuItemSetup();
              break;
          case 6:
            //Tail
              PonyBase.tailLength = floor(selected.tagNo % MenusNames.length);
              PonyBase.specialUpdate();
              GUIMenuItemSetup();
              break;
          case 7:
            //Size
              PonyBase.ponySize = floor(selected.tagNo % MenusNames.length);
              PonyBase.specialUpdate();
              GUIMenuItemSetup();
              break;
        //default
        default:
      }
    }
  println(floor(selected.tagNo / MenusNames.length) + "," + selected.tagNo % MenusNames.length);
}
class ImageSelector{
  //Class for image selection
  //Note: Save functions appear to freeze the program if the user attempts to save as a gif or jpg
  String extension;
  String dir;
  String tempDir;
  String result;

  //TAB ("\t") will be replaced with the name of the file
  String openPrompt;
  String openSuccess;
  String openExtensionFailMsg;
  String openNoSelectionMsg;
  String openUnknownFailMsg;
  
  String revertSuccess;
  String revertNoDirMsg;

  String savePrompt;
  String saveSuccess;
  String saveOverwriteMsg;
  String saveExtensionFailMsg;
  String saveExtensionAddMsg;
  String saveNoSelectionMsg;
  String saveUnknownFailMsg;

  PImage loadedImage = null;
  PImage tempImage = null;

  ImageSelector(String fileExtension){
    extension = fileExtension;

    openPrompt = "Open a \"" + extension + "\" file. . .";
    openSuccess = "\"\t\" was successfully opened.";
    openExtensionFailMsg = "Selected file must be a \"" + extension + "\" file.";
    openNoSelectionMsg = "Request Canceled";
    openUnknownFailMsg = "An unknown error has occured while attempting to load \"\t\"";
    
    revertSuccess = "Reverted to last saved version of \"\t\"";
    revertNoDirMsg = "Failed to load image.";

    savePrompt = "Save image as. . .";
    saveSuccess = "\"\t\" was successfully saved.";
    saveExtensionFailMsg = "Save failed: Image must have \"" + extension + "\" extension.";
    saveExtensionAddMsg = "\"\t\" was successfully saved.  Extension: \"" + fileExtension + "\" was automaticaly added.";
    saveNoSelectionMsg = "Request Canceled";
    saveUnknownFailMsg = "An unknown error has occured while attempting to save \"\t\"";
  }
  
  //Save to dir
  public void saveDir(){
    if(dir != null){
      loadedImage.save(dir);
      println(replaceFileNameEscape(saveSuccess));
    }
    else{
      selectSave();
    }
  }

  //Ask user to select a new directory to save to
  //It will attempt to force the user to add the same extension as the one used
  public void selectSave(){
    //Select output
    tempDir = selectOutput(savePrompt);
    //Check for selection
    if (tempDir != null){
      //Check for extension
      if (tempDir.substring(tempDir.length()-4).equals(extension)){
        loadedImage.save(dir);
        println(replaceFileNameEscapeTemp(saveSuccess));
      }
      else{
        println(replaceFileNameEscapeTemp(saveExtensionFailMsg));
      }
    }
    else{
      println(replaceFileNameEscapeTemp(saveNoSelectionMsg));
    }
  }

  //Ask user to select a new directory to save to and add extension if not provided
  //This does not attempt to prevent the user from adding their own extension
  public void selectSaveAutoReplaceExt(){
    //Select output
    tempDir = selectOutput(savePrompt);
    //Check for selection
    if (tempDir != null){
      //Check for extension
      if (tempDir.substring(tempDir.length()-4).equals(extension)){
        dir = tempDir;
        loadedImage.save(dir);
        println(replaceFileNameEscapeTemp(saveSuccess));
      }
      else{
        tempDir = tempDir + extension;
        dir = tempDir;
        loadedImage.save(dir);
        println(replaceFileNameEscapeTemp(saveExtensionAddMsg));
      }
    }
    else{
      println(replaceFileNameEscapeTemp(saveNoSelectionMsg));
    }
  }

  //Revert (reset loaded image to file)
  public void revert(){
    loadedImage = loadImage(dir);
    println(replaceFileNameEscapeTemp(revertSuccess));
  }

  //Ask user to select a new image to open
  public void selectOpen(){
    //Select input
    tempDir = selectInput(openPrompt);
    //Check for selection
    if (tempDir != null){
      //Check extension
      if (tempDir.substring(tempDir.length()-4).equals(extension)){
        tempImage = loadImage(tempDir, extension.substring(1));
        //Check for errors while loading
        if (tempImage.width != -1 && tempImage.height != -1 && tempImage != null){
          loadedImage = tempImage;
          dir = tempDir;
          println(replaceFileNameEscapeTemp(openSuccess));
        }
        else{
          println(replaceFileNameEscapeTemp(openUnknownFailMsg));
        }
      }
      else{
        println(replaceFileNameEscapeTemp(openExtensionFailMsg));
      }
    }
    else{
      println(replaceFileNameEscapeTemp(openNoSelectionMsg));
    }
  }

  public String replaceFileNameEscape(String target){
    int lastIndexOfSearch = 0;
    while (target.indexOf ('\t', lastIndexOfSearch+1) != -1){
      if (target.indexOf('\t', lastIndexOfSearch+1) > lastIndexOfSearch){
        target = (target.substring(0, target.indexOf("\t")) + fileName(dir) + target.substring(target.indexOf("\t")+1));
      }
    }
    return(target);
  }

  public String replaceFileNameEscapeTemp(String target){
    int lastIndexOfSearch = 0;
    while (target.indexOf ('\t', lastIndexOfSearch+1) != -1){
      if (target.indexOf('\t', lastIndexOfSearch+1) > lastIndexOfSearch){
        target = (target.substring(0, target.indexOf("\t")) + fileName(tempDir) + target.substring(target.indexOf("\t")+1));
      }
    }
    return(target);
  }

  public String fileName(String target){
    int lastIndexOfSearch = 0;
    while (target.indexOf ('/', lastIndexOfSearch+1) != -1){
      if (target.indexOf('/', lastIndexOfSearch+1) > lastIndexOfSearch){
        lastIndexOfSearch = target.indexOf('/', lastIndexOfSearch+1);
      }
    }
    return target.substring(lastIndexOfSearch+1);
  }
}

class MinecraftSkin extends ImageSelector {
  //Extended class for minecraft skins
  //Adds check for size
  String openSizeFailMsg;
  TexturedPlanes PlayerSkin = new TexturedPlanes();
  int transparent = color(255,255,255,0);
  
  MinecraftSkin() {
    super(".png");
    loadedImage = createImage(64, 32, ARGB);
    openSizeFailMsg = "Dimensions of \"\t\" are not 64 x 32";
    selectOpenSkin();
    PlayerSkin.source = loadedImage;
  }

  //Ask user to select a new image to open
  public void selectOpenSkin() {
    //Select input
    tempDir = selectInput(openPrompt);
    //Check for selection
    if (tempDir != null) {
      //Check extension
      if (tempDir.substring(tempDir.length()-4).equals(extension)) {
        tempImage = loadImage(tempDir, extension.substring(1));
        //Check for errors while loading
        if (tempImage.width != -1 && tempImage.height != -1 && tempImage != null) {
          //Check image size
          if (tempImage.width == 64 && tempImage.height == 32) {
            loadedImage = tempImage;
            dir = tempDir;
            PlayerSkin.source = loadedImage;
            println(replaceFileNameEscapeTemp(openSuccess));
          }
          else {
            println(replaceFileNameEscapeTemp(openSizeFailMsg));
          }
        }
        else {
          println(replaceFileNameEscapeTemp(openUnknownFailMsg));
        }
      }
      else {
        println(replaceFileNameEscapeTemp(openExtensionFailMsg));
      }
    }
    else {
      println(replaceFileNameEscapeTemp(openNoSelectionMsg));
    }
  }
  
  public void quickfix(){
    loadedImage.loadPixels();
    for(int i=0; i<2048; i++){
      if(alpha(loadedImage.pixels[i]) == 0){
        loadedImage.pixels[i] = transparent;
      }
    }
    loadedImage.updatePixels();
    PlayerSkin.source = loadedImage;
  }
  
  public void quickfix2(){
    loadedImage.loadPixels();
    for(int i=0; i<2048; i++){
      if(loadedImage.pixels[i] == color(0,0,0)){
        loadedImage.pixels[i] = transparent;
      }
    }
    loadedImage.updatePixels();
    PlayerSkin.source = loadedImage;
  }
}

class TexturedPlanes {
  //Class for enlaging parts of an image to form planes in a 3D space
  PImage source;
  TexturedPlanes() {
    
  }

  //Draw Planes perpendicular to the X axis
  //First letter is which axis to use as X axis. Capital is positive, lowercase is negative.
  //Second letter is which axis to use as Y axis. Capital is positive, lowercase is negative.
  public void YZPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(0, pixelSize, pixelSize);
        translate(0, pixelSize, 0);
      }
      translate(0, -pixelSize*(skinX2-skinX1), pixelSize);
    }
    popMatrix();
  }

  public void YzPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(0, pixelSize, pixelSize);
        translate(0, pixelSize, 0);
      }
      translate(0, -pixelSize*(skinX2-skinX1), -pixelSize);
    }
    popMatrix();
  }

  public void yZPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(0, pixelSize, pixelSize);
        translate(0, -pixelSize, 0);
      }
      translate(0, pixelSize*(skinX2-skinX1), pixelSize);
    }
    popMatrix();
  }

  public void yzPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(0, pixelSize, pixelSize);
        translate(0, -pixelSize, 0);
      }
      translate(0, pixelSize*(skinX2-skinX1), -pixelSize);
    }
    popMatrix();
  }

  //Flip Across Diagonal

  public void ZYPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(0, pixelSize, pixelSize);
        translate(0, 0, pixelSize);
      }
      translate(0, pixelSize, -pixelSize*(skinX2-skinX1));
    }
    popMatrix();
  }

  public void zYPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(0, pixelSize, pixelSize);
        translate(0, 0, -pixelSize);
      }
      translate(0, pixelSize, pixelSize*(skinX2-skinX1));
    }
    popMatrix();
  }

  public void ZyPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(0, pixelSize, pixelSize);
        translate(0, 0, -pixelSize);
      }
      translate(0, -pixelSize, pixelSize*(skinX2-skinX1));
    }
    popMatrix();
  }

  public void zyPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(0, pixelSize, pixelSize);
        translate(0, 0, -pixelSize);
      }
      translate(0, -pixelSize, pixelSize*(skinX2-skinX1));
    }
    popMatrix();
  }

  //Draws Planes perpendicular to the Y axis
  //First letter is which axis to use as X axis. Capital is positive, lowercase is negative.
  //Second letter is which axis to use as Y axis. Capital is positive, lowercase is negative.
  public void XZPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(pixelSize, 0, pixelSize);
        translate(pixelSize, 0, 0);
      }
      translate(-pixelSize*(skinX2-skinX1), 0, pixelSize);
    }
    popMatrix();
  }

  public void xZPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(pixelSize, 0, pixelSize);
        translate(-pixelSize, 0, 0);
      }
      translate(pixelSize*(skinX2-skinX1), 0, pixelSize);
    }
    popMatrix();
  }

  public void XzPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(pixelSize, 0, pixelSize);
        translate(pixelSize, 0, 0);
      }
      translate(-pixelSize*(skinX2-skinX1), 0, -pixelSize);
    }
    popMatrix();
  }

  public void xzPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(pixelSize, 0, pixelSize);
        translate(-pixelSize, 0, 0);
      }
      translate(pixelSize*(skinX2-skinX1), 0, -pixelSize);
    }
    popMatrix();
  }

  //Flip Across Diagonal

  public void ZXPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(pixelSize, 0, pixelSize);
        translate(0, 0, pixelSize);
      }
      translate(pixelSize, 0, -pixelSize*(skinX2-skinX1));
    }
    popMatrix();
  }

  public void zXPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(pixelSize, 0, pixelSize);
        translate(0, 0, -pixelSize);
      }
      translate(pixelSize, 0, pixelSize*(skinX2-skinX1));
    }
    popMatrix();
  }

  public void ZxPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(pixelSize, 0, pixelSize);
        translate(0, 0, pixelSize);
      }
      translate(-pixelSize, 0, -pixelSize*(skinX2-skinX1));
    }
    popMatrix();
  }

  public void zxPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(pixelSize, 0, pixelSize);
        translate(0, 0, -pixelSize);
      }
      translate(-pixelSize, 0, pixelSize*(skinX2-skinX1));
    }
    popMatrix();
  }

  //Draws Planes perpendicular to the Z axis
  //First letter is which axis to use as X axis. Capital is positive, lowercase is negative.
  //Second letter is which axis to use as Y axis. Capital is positive, lowercase is negative.
  public void XYPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(pixelSize, pixelSize, 0);
        translate(pixelSize, 0, 0);
      }
      translate(-pixelSize*(skinX2-skinX1), pixelSize, 0);
    }
    popMatrix();
  }

  public void XyPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(pixelSize, pixelSize, 0);
        translate(pixelSize, 0, 0);
      }
      translate(-pixelSize*(skinX2-skinX1), -pixelSize, 0);
    }
    popMatrix();
  }

  public void xYPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(pixelSize, pixelSize, 0);
        translate(-pixelSize, 0, 0);
      }
      translate(pixelSize*(skinX2-skinX1), pixelSize, 0);
    }
    popMatrix();
  }

  public void xyPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(pixelSize, pixelSize, 0);
        translate(-pixelSize, 0, 0);
      }
      translate(pixelSize*(skinX2-skinX1), -pixelSize, 0);
    }
    popMatrix();
  }

  //Flip Across Diagonal

  public void YXPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(pixelSize, pixelSize, 0);
        translate(0, pixelSize, 0);
      }
      translate(pixelSize, -pixelSize*(skinX2-skinX1), 0);
    }
    popMatrix();
  }

  public void yXPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(pixelSize, pixelSize, 0);
        translate(0, pixelSize, 0);
      }
      translate(-pixelSize, -pixelSize*(skinX2-skinX1), 0);
    }
    popMatrix();
  }

  public void YxPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(pixelSize, pixelSize, 0);
        translate(0, -pixelSize, 0);
      }
      translate(pixelSize, pixelSize*(skinX2-skinX1), 0);
    }
    popMatrix();
  }

  public void yxPlane(int x, int y, int z, int skinX1, int skinY1, int skinX2, int skinY2, int pixelSize) {
    pushMatrix();
    translate(x, y, z);
    for (int bfy=skinY1; bfy<skinY2; bfy++) {
      for (int bfx=skinX1; bfx<skinX2; bfx++) {
        fill(source.pixels[bfy*64+bfx]);
        box(pixelSize, pixelSize, 0);
        translate(0, -pixelSize, 0);
      }
      translate(-pixelSize, pixelSize*(skinX2-skinX1), 0);
    }
    popMatrix();
  }
}

//Keyboard
  public void keyPressed(){
    if(key == ' '){
      
    }
  }

//Mouse
  //Built in Mouse Variables:
  //"mouseButton"
  //"mousePressed"
  //"mouseX"
  //"mouseY"
  //"pmouseX"
  //"pmouseY"
  //Additional variables
  boolean mouseDown;
  boolean leftDown;
  boolean centerDown;
  boolean rightDown;
  
  //Buint in mouse Functions
  public void mouseClicked() {
  }
  
  public void mouseDragged() {
  }
  
  public void mouseMoved() {
  }
  
  public void mouseReleased() {
    mouseDown = false;
    leftDown = false;
    centerDown = false;
    rightDown = false;
  }
  
  public void mousePressed() {
    mouseDown = true;
    switch(mouseButton) {
    case LEFT:
      leftDown = true;
      break;
    case CENTER:
      centerDown = true;
      break;
    case RIGHT:
      rightDown = true;
      break;
    }
  }
  
  //Additional functions
    //Change in X
    public int mouseDX() {
      return(pmouseX - mouseX);
    }
    
    //Change in Y
    public int mouseDY() {
      return(pmouseY - mouseY);
    }
class MCHuman{
  MinecraftSkin Minecraft;
  //GUI Elements
    //Menu Bar
      String[] MenuBar = {"File","Hide/Show","Grid","Pose","Special","Kind"};
      GButton[] Menus = new GButton[MenuBar.length];
    //Names
    //First character is for type of component
    // ! Button
    // @ Radio Button
    // # Checkbox
      final String[][] GUIMenuItemNames = { {"!Open","!Save","!Save as","!Load","#Auto-Load"},
                                            {"#Head","#Body","#Left Leg","#Right Leg","#Left Arm","#Right arm","#Hair"},
                                            {"#Head","#Body","#Left Leg","#Right Leg","#Left Arm","#Right arm","#Hair"},
                                            {"@Normal","@Sleeping","@Sneaking"},
                                            {"#Grid","#Smoothing","#Lights","!Fix Alpha","!Fix Black"},
                                            {"@Earth Pony","@Pegasus","@Unicorn","@Alicorn","@Human"},
                                          };
    //Buttons
      final GButton[][] GUIButtons = { new GButton[GUIMenuItemNames[0].length],
                                       new GButton[GUIMenuItemNames[1].length],
                                       new GButton[GUIMenuItemNames[2].length],
                                       new GButton[GUIMenuItemNames[3].length],
                                       new GButton[GUIMenuItemNames[4].length],
                                       new GButton[GUIMenuItemNames[5].length]
                                     };
                                    
    //Checkboxes
      final GCheckbox[][] GUIChecks = { new GCheckbox[GUIMenuItemNames[0].length],
                                        new GCheckbox[GUIMenuItemNames[1].length],
                                        new GCheckbox[GUIMenuItemNames[2].length],
                                        new GCheckbox[GUIMenuItemNames[3].length],
                                        new GCheckbox[GUIMenuItemNames[4].length],
                                        new GCheckbox[GUIMenuItemNames[5].length]
                                      };
    //Radio Buttons
      final GOptionGroup[] GUIRadioGroups = new GOptionGroup[GUIMenuItemNames.length];
      final GOption[][] GUIRadios = { new GOption[GUIMenuItemNames[0].length],
                                      new GOption[GUIMenuItemNames[1].length],
                                      new GOption[GUIMenuItemNames[2].length],
                                      new GOption[GUIMenuItemNames[3].length],
                                      new GOption[GUIMenuItemNames[4].length],
                                      new GOption[GUIMenuItemNames[5].length]
                                    };
    //Viewing Options
      int pose;
      boolean[] show = {true,true,true,true,true,true,true};
      boolean grid = false;
  MCHuman(MinecraftSkin Skin){
    Minecraft = Skin;
  }
  
  public void drawHuman(){
    humanBody();
    humanHead();
    humanHair();
    humanLeftLeg();
    humanRightLeg();
    humanLeftArm();
    humanRightArm();
  }
  
  public void humanBody(){
    //Top of Human Body
      Minecraft.PlayerSkin.xyPlane(28, 12, 48, 20, 16, 28, 20, 8);
    //Bottom of Human Body
      Minecraft.PlayerSkin.xyPlane(28, 12, -48, 28, 16, 36, 20, 8);
    //Front of Human Body
      Minecraft.PlayerSkin.xzPlane(28, -16, 44, 20, 20, 28, 32, 8);
    //Back of Human Body
      Minecraft.PlayerSkin.XzPlane(-28, 16, 44, 32, 20, 40, 32, 8);
    //Right side of Human Body (Player Perspective)
      Minecraft.PlayerSkin.yzPlane(32, 12, 44, 16, 20, 20, 32, 8);
    //Left side of Human Body (Player Perspective)
      Minecraft.PlayerSkin.YzPlane(-32, -12, 44, 28, 20, 32, 32, 8);
  }
  
  public void humanHead(){
    //Top of head
      Minecraft.PlayerSkin.xyPlane(28, 28, 112, 8, 0, 16, 8, 8);
    //Bottom of head
      Minecraft.PlayerSkin.xYPlane(28, -28, 48, 16, 0, 24, 8, 8);
    //Left of head
      Minecraft.PlayerSkin.YzPlane(-32, -28, 108, 16, 8, 24, 16, 8);
    //Right of head
      Minecraft.PlayerSkin.yzPlane(32, 28, 108, 0, 8, 8, 16, 8);
    //Front of head
      Minecraft.PlayerSkin.xzPlane(28, -32, 108, 8, 8, 16, 16, 8);
    //Back of head
      Minecraft.PlayerSkin.xzPlane(28, 32, 108, 24, 8, 32, 16, 8);
  }
  
  public void humanHair(){
    //Top of hair
      Minecraft.PlayerSkin.xyPlane(32, 32, 116, 40, 0, 48, 8, 9);
    //Bottom of hair
      Minecraft.PlayerSkin.xyPlane(32, 32, 44, 48, 0, 56, 8, 9);
    //Left of hair (Player Perspective)
      Minecraft.PlayerSkin.YzPlane(-36, -32, 111, 48, 8, 56, 16, 9);
    //Right of hair (Player Perspective)
      Minecraft.PlayerSkin.yzPlane(36, 32, 111, 32, 8, 40, 16, 9);
    //Front of hair
      Minecraft.PlayerSkin.xzPlane(32, -36, 111, 40, 8, 48, 16, 9);
    //Back of hair
      Minecraft.PlayerSkin.XzPlane(-32, 36, 111, 56, 8, 64, 16, 9);
  }
  
  public void humanLeftArm(){
    //Top of arm
      Minecraft.PlayerSkin.XyPlane(-60, 12, 48, 44, 16, 48, 20, 8);
    //Bottom of arm
      Minecraft.PlayerSkin.xyPlane(-36, 12, -48, 48, 16, 52, 20, 8);
    //Front of arm
      Minecraft.PlayerSkin.XzPlane(-60, -16, 44, 44, 20, 48, 32, 8);    
    //Back of arm
      Minecraft.PlayerSkin.xzPlane(-36, 16, 44, 52, 20, 56, 32, 8);
    //Left of arm (Outside)
      Minecraft.PlayerSkin.yzPlane(-64, 12, 44, 40, 20, 44, 32, 8);
    //Right of arm (Inside)
      Minecraft.PlayerSkin.YzPlane(-32, -12, 44, 48, 20, 52, 32, 8);
  }
  
  public void humanRightArm(){
    //Top of arm
      Minecraft.PlayerSkin.xyPlane(60, 12, 48, 44, 16, 48, 20, 8);
    //Bottom of arm
      Minecraft.PlayerSkin.xYPlane(60, -12, -48, 48, 16, 52, 20, 8);
    //Front of arm
      Minecraft.PlayerSkin.xzPlane(60, -16, 44, 44, 20, 48, 32, 8);
    //Back of arm
      Minecraft.PlayerSkin.XzPlane(36, 16, 44, 52, 20, 56, 32, 8);
    //Right of arm (Outside)
      Minecraft.PlayerSkin.yzPlane(64, 12, 44, 40, 20, 44, 32, 8);
    //Left of arm (Inside)
      Minecraft.PlayerSkin.YzPlane(32, -12, 44, 48, 20, 52, 32, 8);
  }
  
  public void humanLeftLeg(){
    //Top of leg
      Minecraft.PlayerSkin.XyPlane(-28, 12, -48, 4, 16, 8, 20, 8);
    //Bottom of leg
      Minecraft.PlayerSkin.XYPlane(-28, -12, -144, 8, 16, 12, 20, 8);
    //Front of leg
      Minecraft.PlayerSkin.XzPlane(-28, -16, -52, 4, 20, 8, 32, 8);
    //Back of leg
      Minecraft.PlayerSkin.xzPlane(-4, 16, -52, 12, 20, 16, 32, 8);
    //Left of leg (Outside)
      Minecraft.PlayerSkin.yzPlane(-32, 12, -52, 0, 20, 4, 32, 8);
    //Right of leg (Inside)
      Minecraft.PlayerSkin.YzPlane(0, -12, -52, 8, 20, 12, 32, 8);
  }
  
  public void humanRightLeg(){
    //Top of leg
      Minecraft.PlayerSkin.xyPlane(28, 12, -48, 4, 16, 8, 20, 8);
    //Bottom of leg
      Minecraft.PlayerSkin.xYPlane(28, -12, -144, 8, 16, 12, 20, 8);
    //Front of leg
      Minecraft.PlayerSkin.xzPlane(28, -16, -52, 4, 20, 8, 32, 8);
    //Back of leg
      Minecraft.PlayerSkin.XzPlane(4, 16, -52, 12, 20, 16, 32, 8);
    //Right of leg (Outside)
      Minecraft.PlayerSkin.yzPlane(32, 12, -52, 0, 20, 4, 32, 8);
    //Left of leg (Inside)
      Minecraft.PlayerSkin.YzPlane(0, -12, -52, 8, 20, 12, 32, 8);
  }
  
  public void outline(){
      stroke(0);
      noFill();
      strokeWeight(2);
    //draw outline of body
      box(64, 32, 96);
    //draw outline of head
      pushMatrix();
      translate(0, 0, 80);
      box(64, 64, 64);
      popMatrix();
    //draw outline of hair
      pushMatrix();
      translate(0, 0, 80);
      box(72, 72, 72);
      popMatrix();
    //draw outline of left leg
      pushMatrix();
      translate(-16, 0, -96);
      box(32, 32, 96);
      popMatrix();
    //draw outline of right leg
      pushMatrix();
      translate(16, 0, -96);
      box(32, 32, 96);
      popMatrix();
    //draw outline of left arm
      pushMatrix();
      translate(-48, 0, 0);
      box(32, 32, 96);
      popMatrix();
    //draw outline of right arm
      pushMatrix();
      translate(48, 0, 0);
      box(32, 32, 96);
      popMatrix();
  }
}
class MCPonyBase{
  //Observations on different sizes based on screenshots
/*Pixel Size    Head    Body   Legs
  Normal(unit)  8x8     8x8    8x8
  Foal          6x6     4x4    4x4
  Large         8x8     10x10  10x10
  Alicorn       8x8     8x10   
  
  Trial 1 Front
             Head     Leg(BCRGBCYM)  Horn Width
  Normal     44x44    40x40          6
  Foal       40x40    26x18          6
  Large      44x44    48x48          6
  Alicorn    44x44    40x46          6
  
  Leg 1.2
  
  Trial 2 Back
             Head     Leg(BCRGBCYM)  Flank
  Normal     42x42    48x48          50x50
  Foal       38x38    26x18          28x28
  Large      42x42    58x56          60x64
  Alicorn    42x42    48x56          50x50
 
  Leg 
  
*/
  //Special Features
    int race;
      //1: Earth Pony
      final int raceEarthColor = color(249, 177, 49, 255);
      //2: Pegasus
      final int racePegasusColor = color(136, 202, 240, 255);
      //3: Unicorn
      final int raceUnicornColor = color(209, 159, 228, 255);
      //4: Alicorn
      final int raceAlicornColor = color(254, 249, 252, 255);
      //0:  Default Human color(0, 0, 0, 0)
    int tailLength;
      //0: Stub
      final int tail0Color = color(66, 88, 68, 255);
      //1: 1/4
      final int tail1Color = color(70, 142, 136, 255);
      //2: 2/4
      final int tail2Color = color(83, 75, 118, 255);
      //3: 3/4
      final int tail3Color = color(138, 107, 127, 255);
      //0:  Default Full color(0, 0, 0, 0)
    int male;
      //1: Male
      final int maleColor = color(255, 255, 255, 255);
      //0: Default Female color(0, 0, 0, 0)
    int ponySize;
      //1: Foal
      final int sizeFoalColor = color(255, 190, 83, 255);
      //2: Large
      final int sizeLargeColor = color(206, 50, 84, 255);
      //3: Alicorn
      final int sizeAlicornColor = color(42, 60, 120, 255);
      //0:  Normal Full color(0, 0, 0, 0)
  //Viewing Options
    int pose;
    boolean[] show = {true,true,true,true,true,true,true,true,true,true,true,true,true};
    //boolean[] grid = {false,false,false,false,false,false,false,false,false,false,false,false,false};
    boolean grid = false;
  //GUI Elements
    //Menu Bar
      String[] MenuBar = {"File","Hide/Show","Useless Menu","Pose","Special","Kind","Tail","Size"};
      GButton[] Menus = new GButton[MenuBar.length];
    //Menu Items
      final String[][] GUIMenuItemNames = { {"!Open","!Save","!Save as","!Load","#Auto-Load"},
                                            {"#Head","#Ears","#Snuzzle","#Neck","#Body","#Left Legs","#Right Legs","#Tail 1","#Tail 2","#Mane","#Left Wing","#Right Wing","#Horn"},
                                            {"!Useless"},
                                            {"@Normal","@Sleeping","@Sneaking","@Flying","@Magic Spell"},
                                            {"#Grid","#Smoothing","#Lights","!Fix Alpha","!Fix Black"},
                                            {"@Earth Pony","@Pegasus","@Unicorn","@Alicorn","@Human","#Male"},
                                            {"@Stub","@1/4","@2/4","@3/4","@Full"},
                                            {"@Normal","@Foal","@Large","@Alicorn"}
                                          };
      //Buttons
        final GButton[][] GUIButtons = { new GButton[GUIMenuItemNames[0].length],
                                         new GButton[GUIMenuItemNames[1].length],
                                         new GButton[GUIMenuItemNames[2].length],
                                         new GButton[GUIMenuItemNames[3].length],
                                         new GButton[GUIMenuItemNames[4].length],
                                         new GButton[GUIMenuItemNames[5].length],
                                         new GButton[GUIMenuItemNames[6].length],
                                         new GButton[GUIMenuItemNames[7].length]
                                       };
                                      
      //Checkboxes
        final GCheckbox[][] GUIChecks = { new GCheckbox[GUIMenuItemNames[0].length],
                                          new GCheckbox[GUIMenuItemNames[1].length],
                                          new GCheckbox[GUIMenuItemNames[2].length],
                                          new GCheckbox[GUIMenuItemNames[3].length],
                                          new GCheckbox[GUIMenuItemNames[4].length],
                                          new GCheckbox[GUIMenuItemNames[5].length],
                                          new GCheckbox[GUIMenuItemNames[6].length],
                                          new GCheckbox[GUIMenuItemNames[7].length]
                                        };
      //Radio Buttons
        final GOptionGroup[] GUIRadioGroups = new GOptionGroup[GUIMenuItemNames.length];
        final GOption[][] GUIRadios = { new GOption[GUIMenuItemNames[0].length],
                                        new GOption[GUIMenuItemNames[1].length],
                                        new GOption[GUIMenuItemNames[2].length],
                                        new GOption[GUIMenuItemNames[3].length],
                                        new GOption[GUIMenuItemNames[4].length],
                                        new GOption[GUIMenuItemNames[5].length],
                                        new GOption[GUIMenuItemNames[6].length],
                                        new GOption[GUIMenuItemNames[7].length]
                                      };
  //Detect Special features
   public void specialScan(MinecraftSkin Skin) {
      //Kind
        switch(Skin.loadedImage.pixels[0]){
          case -413391:
            race = 1;
            println("Race: Earth Pony");
            break;
          case -7812368:
            race = 2;
            println("Race: Pegasus");
            break;
          case -3039260:
            race = 3;
            println("Race: Unicorn");
            break;
          case -67076:
            race = 4;
            println("Race: Alicorn");
            break;
          default:
            race = 0;
            println("Non-pony skin detected, race set to: Human");
        }
      //Tail
        switch(Skin.loadedImage.pixels[1]){
          case -12429244:
            tailLength = 0;
            println("Tail Length: Stub");
            break;
          case -12153208:
            tailLength = 1;
            println("Tail Length: 1/4");
            break;
          case -11318410:
            tailLength = 2;
            println("Tail Length: 2/4");
            break;
          case -7705729:
            tailLength = 3;
            println("Tail Length: 3/4");
            break;
          default:
            tailLength = 4;
            println("Tail Length: Full");
        }
      //Gender
        switch(Skin.loadedImage.pixels[2]){
          case -1:
            male = 1;
            println("Gender: Male");
            break;
          default:
            male = 0;
            println("Gender: Female");
        }
      //Size
        switch(PApplet.parseInt(Skin.loadedImage.pixels[3])){
          case -16813:
            ponySize = 1;
            println("Size: Foal");
            break;
          case -3263916:
            ponySize = 2;
            println("Size: Large");
            break;
          case -14009224:
            ponySize = 3;
            println("Size: Alicorn");
            break;
          default:
            ponySize = 0;
            println("Size: Normal");
        }
    }
  //Change special features
    public void specialUpdate() {
      //Kind
        switch(PonyBase.race) {
          //Earth Pony
            case 1:
              Minecraft.loadedImage.pixels[0] = raceEarthColor;
              break;
          //Pegasus
            case 2:
              Minecraft.loadedImage.pixels[0] = racePegasusColor;
              break;
          //Unicorn
            case 3:
              Minecraft.loadedImage.pixels[0] = raceUnicornColor;
              break;
          //Alicorn
            case 4:
              Minecraft.loadedImage.pixels[0] = raceAlicornColor;
              break;
          //Error
            default:
              Minecraft.loadedImage.pixels[0] = color(0, 0, 0, 0);
        }
      //Tail
        switch(PonyBase.tailLength) {
          //  Stub
            case 0:
              Minecraft.loadedImage.pixels[1] = tail0Color;
              break;
          //  1/4
            case 1:
              Minecraft.loadedImage.pixels[1] = tail1Color;
              break;
          //  2/4
            case 2:
              Minecraft.loadedImage.pixels[1] = tail2Color;
              break;
          //  3/4
            case 3:
              Minecraft.loadedImage.pixels[1] = tail3Color;
              break;
          //  Full
            default:
              Minecraft.loadedImage.pixels[1] = color(0, 0, 0, 0);
        }
      //Gender
        if (PonyBase.male == 1) {
          Minecraft.loadedImage.pixels[2] = maleColor;
        }
        else {
          Minecraft.loadedImage.pixels[2] = color(0, 0, 0, 0);
        }
      //Size
        switch(PonyBase.ponySize){
          //Foal
            case 1:
              Minecraft.loadedImage.pixels[3] = sizeFoalColor;
              break;
          //Large
            case 2:
              Minecraft.loadedImage.pixels[3] = sizeLargeColor;
              break;
          //Alicorn
            case 3:
              Minecraft.loadedImage.pixels[3] = sizeAlicornColor;
              break;
          //Normal
            default:
              Minecraft.loadedImage.pixels[3] = color(0, 0, 0, 0);
        }
    }
}
class MCPonyNormal{
  //Normal Pony Model
  MinecraftSkin Minecraft;
  MCPonyBase PonyBase;
    
  MCPonyNormal(MinecraftSkin Skin, MCPonyBase Base){
    Minecraft = Skin;
    PonyBase = Base;
    PonyBase.specialScan(Minecraft);
  }
  
  public void drawPony() {
    if(PonyBase.grid){
      strokeWeight(2);
      stroke(0, 0, 0, 255);
    }
    //Head
      if(PonyBase.show[0] == true){
        head();
      }
    //Ears
      if(PonyBase.show[1] == true){
        earLA();
        earRA();
      }
    //Snuzz;e
      if(PonyBase.show[2] == true){
        if (PonyBase.male == 1) {
          snuzzleM();
        }
        else {
          snuzzleF();
        }
      }
    //Neck
      if(PonyBase.show[3] == true){
        neck();
      }
    //Body
      if(PonyBase.show[4] == true){
        bodyA();
      }
    //Left Legs
      if(PonyBase.show[5] == true){
        legFL();
        legHLA();
      }
    //Right Legs
      if(PonyBase.show[6] == true){
        legFR();
        legHRA();
      }
    //Tail 1
      if(PonyBase.show[7] == true){
        tailAS();
      }
    //Tail 2
      if(PonyBase.show[8] == true){
        tailAL();
      }
    //Mane
      if(PonyBase.show[9] == true){
        mane();
      }
    //Magic
      switch(PonyBase.race) {
        case 1:
          //Earth Pony
          break;
        case 2:
          //Pegasus
            //Left Wing
              if(PonyBase.show[10] == true){
                LWing();
              }
            //Right Wing
              if(PonyBase.show[11] == true){
                RWing();
              }
          break;
        case 3:
          //Unicorn
            //Horn
              if(PonyBase.show[12] == true){
                hornA();
              }
            break;
        case 4:
          //Alicorn
            //Left Wing
              if(PonyBase.show[10] == true){
                LWing();
              }
            //Right Wing
              if(PonyBase.show[11] == true){
                RWing();
              }
            //Horn
              if(PonyBase.show[12] == true){
                hornA();
              }
            break;
        default:
          break;
      }
  }
  
  public void tailAL() {
    if (PonyBase.tailLength > 0) {
      pushMatrix();
      //Top of Tail
      Minecraft.PlayerSkin.xyPlane(12, 108, 48, 32, 0, 36, 4, 8);
      translate(0, 108, 44);
      //Tail Loop
      for (int i=0; i<PonyBase.tailLength; i++) {
        if (i%2 == 0) {
          tailSegment1();
        }
        else {
          tailSegment2();
        }
        translate(0, 0, -32);
      }
      //Bottom of Tail
      Minecraft.PlayerSkin.xyPlane(12, 0, 4, 32, 0, 36, 4, 8);
      popMatrix();
    }
  }
  
  public void earRA() {
    pushMatrix();
    translate(0, -8, 16);
    //Top of ear
    Minecraft.PlayerSkin.xyPlane(28, -44, 112, 14, 16, 16, 18, 8);
    //Bottom of ear
    //???
    //Left of ear (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -52, 108, 16, 18, 18, 20, 8);
    //Right of ear (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(32, -44, 108, 12, 18, 14, 20, 8);
    //Front of ear
    Minecraft.PlayerSkin.xzPlane(28, -56, 108, 14, 18, 16, 20, 8);
    //Back of ear
    Minecraft.PlayerSkin.XzPlane(20, -40, 108, 18, 18, 20, 20, 8);
    popMatrix();
  }
  
  public void earLA() {
    pushMatrix();
    translate(0, -8, 16);
    //Top of ear
    Minecraft.PlayerSkin.XyPlane(-28, -44, 112, 14, 16, 16, 18, 8);
    //Bottom of ear
    //???
    //Left of ear (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -52, 108, 16, 18, 18, 20, 8);
    //Right of ear (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(-32, -44, 108, 12, 18, 14, 20, 8);
    //Front of ear
    Minecraft.PlayerSkin.XzPlane(-28, -56, 108, 14, 18, 16, 20, 8);
    //Back of ear
    Minecraft.PlayerSkin.xzPlane(-20, -40, 108, 18, 18, 20, 20, 8);
    popMatrix();
  }
  
  public void tailAS() {
    pushMatrix();
    translate(0, 70, 24);
    rotateX(-1*PI/3);
    translate(0, 0, -20);
//    //Old Left of Tail (Pony Perspective)
//    Minecraft.PlayerSkin.yZPlane(8, 4, 0, 32, 0, 34, 6, 8);
//    //Old Right of Tail (Pony Perspective)
//    Minecraft.PlayerSkin.yZPlane(-8, 4, 0, 32, 0, 34, 6, 8);
    //Left of Tail (Pony Perspective)
    Minecraft.PlayerSkin.ZYPlane(8, -4, 0, 32, 0, 38, 2, 8);
    //Right of Tail (Pony Perspective)
    Minecraft.PlayerSkin.ZYPlane(-8, -4, 0, 32, 0, 38, 2, 8);
//    //Old Top of Tail
//    Minecraft.PlayerSkin.xZPlane(4, -8, 0, 32, 0, 34, 6, 8);
    // Top of Tail
    Minecraft.PlayerSkin.xzPlane(4, -8, 40, 32, 0, 34, 6, 8);
    //Bottom of Tail
    Minecraft.PlayerSkin.xZPlane(4, 8, 0, 32, 0, 34, 6, 8);
    //Front of tail (Hidden)
    //(???)
//    //Old Back of Tail (End)
//    Minecraft.PlayerSkin.xyPlane(4, 4, 44, 32, 0, 34, 2, 8);
    //Back of Tail (End)
    Minecraft.PlayerSkin.xYPlane(4, -4, 44, 32, 0, 34, 2, 8);
    popMatrix();
  }
  
  public void tailSegment1() {
    //Left of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -24, 0, 36, 0, 40, 4, 8);
    //Right of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -24, 0, 36, 0, 40, 4, 8);
    //Back of Tail
    Minecraft.PlayerSkin.xzPlane(12, 4, 0, 32, 0, 36, 4, 8);
    //Front of Tail
    Minecraft.PlayerSkin.xzPlane(12, -28, 0, 32, 0, 36, 4, 8);
  }
  
  public void tailSegment2() {
    //Left of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -24, 0, 36, 4, 40, 8, 8);
    //Right of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -24, 0, 36, 4, 40, 8, 8);
    //Back of Tail
    Minecraft.PlayerSkin.xzPlane(12, 4, 0, 32, 4, 36, 8, 8);
    //Front of Tail
    Minecraft.PlayerSkin.xzPlane(12, -28, 0, 32, 4, 36, 8, 8);
  }
  
  public void snuzzleM() {
    pushMatrix();
    translate(0, -8, 16);
    //Top of snuzzle
    Minecraft.PlayerSkin.xyPlane(12, -100, 56, 10, 13, 14, 14, 8);
    //Bottom of snuzzle
    Minecraft.PlayerSkin.xyPlane(12, -100, 32, 10, 15, 14, 16, 8);
    //Right of snuzzle (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(16, -100, 52, 10, 13, 11, 16, 8);
    //Left of snuzzle (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(-16, -100, 52, 13, 13, 14, 16, 8);
    //Front of snuzzle
    Minecraft.PlayerSkin.xzPlane(12, -104, 52, 10, 13, 14, 16, 8);
    popMatrix();
  }
  
  public void snuzzleF() {
    pushMatrix();
    translate(0, -8, 16);
    //Right of snuzzle (Pony Perspective)
    //Top
    Minecraft.PlayerSkin.yzPlane(8, -100, 52, 11, 12, 12, 13, 8);
    //Bottom
    Minecraft.PlayerSkin.yzPlane(16, -100, 44, 9, 14, 10, 16, 8);
    //Left of snuzzle (Pony Perspective)
    //Top
    Minecraft.PlayerSkin.yzPlane(-8, -100, 52, 12, 12, 13, 13, 8);
    //Bottom
    Minecraft.PlayerSkin.yzPlane(-16, -100, 44, 14, 14, 15, 16, 8);
    //Top of snuzzle
    //Right (Pony Perspective)
    Minecraft.PlayerSkin.xyPlane(12, -100, 48, 9, 14, 10, 15, 8);
    //Middle
    Minecraft.PlayerSkin.xyPlane(4, -100, 56, 11, 12, 13, 13, 8);
    //Left (Pony Perspective)
    Minecraft.PlayerSkin.xyPlane(-12, -100, 48, 14, 14, 15, 15, 8);
    //Bottom of snuzzle
    Minecraft.PlayerSkin.xyPlane(12, -100, 32, 10, 15, 14, 16, 8);
    //Front of snuzzle
    //Top
    Minecraft.PlayerSkin.xzPlane(4, -104, 52, 11, 13, 13, 14, 8);
    //Bottom
    Minecraft.PlayerSkin.xzPlane(12, -104, 44, 10, 14, 14, 16, 8);
    popMatrix();
  }
  
  public void neck() {
    pushMatrix();
    translate(0, -60, 56);
    rotateX(PI/12);
    //Left of neck (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -8, -6, 0, 16, 4, 20, 8);
    //Rignt of neck (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -8, -6, 0, 16, 4, 20, 8);
    //Front of neck
    Minecraft.PlayerSkin.xzPlane(12, 20, -6, 0, 16, 4, 20, 8);
    //Back of neck
    Minecraft.PlayerSkin.xzPlane(12, -12, -6, 0, 16, 4, 20, 8);
    popMatrix();
  }
  
  public void legHLA() {
    //Top of leg
    Minecraft.PlayerSkin.XyPlane(-28, 44, -32, 4, 16, 8, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.XyPlane(-28, 44, -128, 8, 16, 12, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.XzPlane(-28, 16, -36, 4, 20, 8, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.xzPlane(-4, 48, -36, 12, 20, 16, 32, 8);
    //Left of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(-32, 44, -36, 0, 20, 4, 32, 8);
    //Right of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 8, 20, 12, 32, 8);
  }
  
  public void legHRA() {
    //Top of leg
    Minecraft.PlayerSkin.xyPlane(28, 44, -32, 4, 16, 8, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.xyPlane(28, 44, -128, 8, 16, 12, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.xzPlane(28, 16, -36, 4, 20, 8, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.XzPlane(4, 48, -36, 12, 20, 16, 32, 8);
    //Right of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(32, 44, -36, 0, 20, 4, 32, 8);
    //Left of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 8, 20, 12, 32, 8);
  }
  
  public void bodyA() {
    //Front of Pony (Chest)
      Minecraft.PlayerSkin.xzPlane(28, -64, 28, 20, 20, 28, 28, 8);
    //Back of pony (Flank)
      //Top
        Minecraft.PlayerSkin.xzPlane(28, 64, 28, 36, 16, 44, 20, 8);
      //Bottom
        Minecraft.PlayerSkin.xzPlane(28, 64, -4, 36, 16, 44, 20, 8);
    //Top of Body
      //Front (Withers)
      Minecraft.PlayerSkin.xyPlane(28, -36, 32, 20, 16, 28, 20, 8);
      //Back
      Minecraft.PlayerSkin.XYPlane(-28, -28, 32, 32, 20, 40, 32, 8);
    //Bottom of body
      //Front
        Minecraft.PlayerSkin.xyPlane(28, -36, -32, 28, 16, 36, 20, 8);
      //Middle (Barrel)
        Minecraft.PlayerSkin.xYPlane(28, -28, -32, 56, 0, 64, 8, 8);
      //Back
        Minecraft.PlayerSkin.xYPlane(28, 36, -32, 36, 16, 44, 20, 8);
    //Left side of Pony (Pony Perspective)
      //Left Shoulder
        Minecraft.PlayerSkin.YzPlane(-32, -60, 28, 28, 20, 32, 28, 8);
      //Middle
        Minecraft.PlayerSkin.YzPlane(-32, -28, 28, 24, 0, 32, 8, 8);
      //Back (Cutie Mark)
        Minecraft.PlayerSkin.YzPlane(-32, 36, 28, 4, 0, 8, 8, 8);
    //Right side of Pony (Pony Perspective)
      //Shoulder
        Minecraft.PlayerSkin.yzPlane(32, -36, 28, 16, 20, 20, 28, 8);
      //Middle
        Minecraft.PlayerSkin.YzPlane(32, -28, 28, 24, 0, 32, 8, 8);
      //Back (Right Cutie Mark)
        Minecraft.PlayerSkin.YzPlane(32, 36, 28, 4, 0, 8, 8, 8);
  }
  
  public void hornA() {
    pushMatrix();
    translate(0, -108, 120);
    rotateX(PI/6);
    //Tip of horn
    Minecraft.PlayerSkin.xyPlane(0, 0, 20, 1, 3, 2, 4, 8);
    //Front of horn
    Minecraft.PlayerSkin.xzPlane(0, -4, 16, 1, 4, 2, 8, 8);
    //Back of horn
    Minecraft.PlayerSkin.xzPlane(0, 4, 16, 3, 4, 4, 8, 8);
    //Left of Horn
    Minecraft.PlayerSkin.yzPlane(-4, 0, 16, 2, 4, 3, 8, 8);
    //Right of Horn
    Minecraft.PlayerSkin.yzPlane(4, 0, 16, 0, 4, 1, 8, 8);
    popMatrix();
  }
  
  public void LWing() {
    //Top of wing
    //Front
    Minecraft.PlayerSkin.xYPlane(-36, -28, 24, 62, 18, 64, 24, 8);
    //Back
    Minecraft.PlayerSkin.xYPlane(-36, 20, 8, 62, 24, 64, 26, 8);
    //Bottom of wing
    //Front
    Minecraft.PlayerSkin.XYPlane(-44, -28, -24, 58, 18, 60, 24, 8);
    //Back
    Minecraft.PlayerSkin.XYPlane(-44, 20, -8, 58, 24, 60, 26, 8);
    //Front of Wing
    //Top
    Minecraft.PlayerSkin.XzPlane(-44, -32, 20, 58, 16, 60, 18, 8);
    //Middle
    Minecraft.PlayerSkin.XzPlane(-44, -32, 4, 58, 16, 60, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.XzPlane(-44, -32, -12, 58, 16, 60, 18, 8);
    //Back of Wing
    //Top
    Minecraft.PlayerSkin.XzPlane(-44, 16, 20, 60, 16, 62, 18, 8);
    //Middle
    Minecraft.PlayerSkin.XzPlane(-44, 32, 4, 60, 16, 62, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.XzPlane(-44, 16, -12, 60, 16, 62, 18, 8);
    //Outside of Wing
    //Top
    Minecraft.PlayerSkin.zYPlane(-48, -28, 20, 56, 18, 58, 24, 8);
    //Middle
    Minecraft.PlayerSkin.zYPlane(-48, -28, 4, 56, 18, 58, 26, 8);
    //Bottom
    Minecraft.PlayerSkin.zYPlane(-48, -28, -12, 56, 18, 58, 24, 8);
  }
  
  public void RWing() {
    //Top of wing
    //Front
    Minecraft.PlayerSkin.XYPlane(36, -28, 24, 62, 18, 64, 24, 8);
    //Back
    Minecraft.PlayerSkin.XYPlane(36, 20, 8, 62, 24, 64, 26, 8);
    //Bottom of wing
    //Front
    Minecraft.PlayerSkin.xYPlane(44, -28, -24, 58, 18, 60, 24, 8);
    //Back
    Minecraft.PlayerSkin.xYPlane(44, 20, -8, 58, 24, 60, 26, 8);
    //Front of Wing
    //Top
    Minecraft.PlayerSkin.xzPlane(44, -32, 20, 58, 16, 60, 18, 8);
    //Middle
    Minecraft.PlayerSkin.xzPlane(44, -32, 4, 58, 16, 60, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.xzPlane(44, -32, -12, 58, 16, 60, 18, 8);
    //Back of Wing
    //Top
    Minecraft.PlayerSkin.xzPlane(44, 16, 20, 60, 16, 62, 18, 8);
    //Middle
    Minecraft.PlayerSkin.xzPlane(44, 32, 4, 60, 16, 62, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.xzPlane(44, 16, -12, 60, 16, 62, 18, 8);
    //Outside of Wing
    //Top
    Minecraft.PlayerSkin.zYPlane(48, -28, 20, 56, 18, 58, 24, 8);
    //Middle
    Minecraft.PlayerSkin.zYPlane(48, -28, 4, 56, 18, 58, 26, 8);
    //Bottom
    Minecraft.PlayerSkin.zYPlane(48, -28, -12, 56, 18, 58, 24, 8);
  }
  
  public void legFL() {
    //Top of leg
    Minecraft.PlayerSkin.XyPlane(-28, -28, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.XyPlane(-28, -28, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.XzPlane(-28, -56, -36, 44, 20, 48, 32, 8);  
    //Back of leg
    Minecraft.PlayerSkin.xzPlane(-4, -24, -36, 52, 20, 56, 32, 8);
    //Left of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(-32, -28, -36, 40, 20, 44, 32, 8);
    //Right of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, -52, -36, 48, 20, 52, 32, 8);
  }
  
  public void legHL() {
    //Top of leg
    Minecraft.PlayerSkin.XyPlane(-28, 44, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.XyPlane(-28, 44, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.XzPlane(-28, 16, -36, 44, 20, 48, 32, 8);  
    //Back of leg
    Minecraft.PlayerSkin.xzPlane(-4, 48, -36, 52, 20, 56, 32, 8);
    //Left of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(-32, 44, -36, 40, 20, 44, 32, 8);
    //Right of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 48, 20, 52, 32, 8);
  }
  
  public void legFR() {
    //Top of leg
    Minecraft.PlayerSkin.xyPlane(28, -28, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.xyPlane(28, -28, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.xzPlane(28, -56, -36, 44, 20, 48, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.XzPlane(4, -24, -36, 52, 20, 56, 32, 8);
    //Right of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(32, -28, -36, 40, 20, 44, 32, 8);
    //Left of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, -52, -36, 48, 20, 52, 32, 8);
  }
  
  public void legHR() {
    //Top of leg
    Minecraft.PlayerSkin.xyPlane(28, 44, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.xyPlane(28, 44, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.xzPlane(28, 16, -36, 44, 20, 48, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.XzPlane(4, 48, -36, 52, 20, 56, 32, 8);
    //Right of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(32, 44, -36, 40, 20, 44, 32, 8);
    //Left of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 48, 20, 52, 32, 8);
  }
  
  public void mane() {
    pushMatrix();
      translate(0, -8, 16);
      //Top of mane
      Minecraft.PlayerSkin.xyPlane(32, -33, 100, 40, 0, 48, 8, 9);
      //Bottom of mane
      Minecraft.PlayerSkin.xyPlane(32, -33, 29, 48, 0, 56, 8, 9);
      //Left of mane (Pony Perspective)
      Minecraft.PlayerSkin.YzPlane(-35, -96, 96, 48, 8, 56, 16, 9);
      //Right of mane (Pony Perspective)
      Minecraft.PlayerSkin.yzPlane(35, -33, 96, 32, 8, 40, 16, 9);
      //Front of mane
      Minecraft.PlayerSkin.xzPlane(32, -100, 96, 40, 8, 48, 16, 9);
      //Back of mane
      Minecraft.PlayerSkin.XzPlane(-31, -29, 96, 56, 8, 64, 16, 9);
    popMatrix();
  }
  
  public void head() {
    pushMatrix();
      translate(0, -8, 16);
      //Top of head
      Minecraft.PlayerSkin.xyPlane(28, -36, 96, 8, 0, 16, 8, 8);
      //Bottom of head
      Minecraft.PlayerSkin.xYPlane(28, -92, 32, 16, 0, 24, 8, 8);
      //Left of head
      Minecraft.PlayerSkin.YzPlane(-32, -92, 92, 16, 8, 24, 16, 8);
      //Right of head
      Minecraft.PlayerSkin.yzPlane(32, -36, 92, 0, 8, 8, 16, 8);
      //Front of head
      Minecraft.PlayerSkin.xzPlane(28, -96, 92, 8, 8, 16, 16, 8);
      //Back of head
      Minecraft.PlayerSkin.XzPlane(-28, -32, 92, 24, 8, 32, 16, 8);
    popMatrix();
  }
}
class MCPonyFoal{
  //Normal Pony Model
  MinecraftSkin Minecraft;
  MCPonyBase PonyBase;
    
  MCPonyFoal(MinecraftSkin Skin, MCPonyBase Base){
    Minecraft = Skin;
    PonyBase = Base;
    PonyBase.specialScan(Minecraft);
  }
  
  public void drawPony() {
    if(PonyBase.grid){
      strokeWeight(2);
      stroke(0, 0, 0, 255);
    }
      pushMatrix();
      scale(0.9f);
      translate(0,28,-28);
    //Head
      if(PonyBase.show[0] == true){
        head();
      }
    //Mane
      if(PonyBase.show[9] == true){
        mane();
      }
    //Ears
      if(PonyBase.show[1] == true){
        earLA();
        earRA();
      }
    //Snuzzle
      if(PonyBase.show[2] == true){
        if (PonyBase.male == 1) {
          snuzzleM();
        }
        else {
          snuzzleF();
        }
      }
      popMatrix();
      pushMatrix();
      scale(0.75f);
      translate(0,8,-16);
    //Neck
      if(PonyBase.show[3] == true){
        neck();
      }
      popMatrix();
      pushMatrix();
      scale(0.625f);
    //Body
      if(PonyBase.show[4] == true){
        bodyA();
      }
    //Tail 1
      if(PonyBase.show[7] == true){
        tailAS();
      }
    //Tail 2
      if(PonyBase.show[8] == true){
        tailAL();
      }
      scale(1, 1, 0.75f);
      translate(0, 0, -10);
    //Left Legs
      if(PonyBase.show[5] == true){
        legFL();
        legHLA();
      }
    //Right Legs
      if(PonyBase.show[6] == true){
        legFR();
        legHRA();
      }
      popMatrix();
    //Magic
      switch(PonyBase.race) {
        case 1:
          //Earth Pony
          break;
        case 2:
          //Pegasus
            //Left Wing
            pushMatrix();
            scale(0.625f);
              if(PonyBase.show[10] == true){
                LWing();
              }
            //Right Wing
              if(PonyBase.show[11] == true){
                RWing();
              }
            popMatrix();
          break;
        case 3:
          //Unicorn
            //Horn
              if(PonyBase.show[12] == true){
                hornA();
              }
            break;
        case 4:
          //Alicorn
              pushMatrix();
              scale(0.625f);
            //Left Wing
              if(PonyBase.show[10] == true){
                LWing();
              }
            //Right Wing
              if(PonyBase.show[11] == true){
                RWing();
              }
              popMatrix();
              pushMatrix();
              translate(0,36,-38);
            //Horn
              if(PonyBase.show[12] == true){
                hornA();
              }
              popMatrix();
            break;
        default:
          break;
      }
  }
  
  public void tailAL() {
    if (PonyBase.tailLength > 0) {
      pushMatrix();
      //Top of Tail
      Minecraft.PlayerSkin.xyPlane(12, 108, 48, 32, 0, 36, 4, 8);
      translate(0, 108, 44);
      //Tail Loop
      for (int i=0; i<PonyBase.tailLength; i++) {
        if (i%2 == 0) {
          tailSegment1();
        }
        else {
          tailSegment2();
        }
        translate(0, 0, -32);
      }
      //Bottom of Tail
      Minecraft.PlayerSkin.xyPlane(12, 0, 4, 32, 0, 36, 4, 8);
      popMatrix();
    }
  }
  
  public void earRA() {
    pushMatrix();
    translate(0, -8, 16);
    //Top of ear
    Minecraft.PlayerSkin.xyPlane(28, -44, 112, 14, 16, 16, 18, 8);
    //Bottom of ear
    //???
    //Left of ear (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -52, 108, 16, 18, 18, 20, 8);
    //Right of ear (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(32, -44, 108, 12, 18, 14, 20, 8);
    //Front of ear
    Minecraft.PlayerSkin.xzPlane(28, -56, 108, 14, 18, 16, 20, 8);
    //Back of ear
    Minecraft.PlayerSkin.XzPlane(20, -40, 108, 18, 18, 20, 20, 8);
    popMatrix();
  }
  
  public void earLA() {
    pushMatrix();
    translate(0, -8, 16);
    //Top of ear
    Minecraft.PlayerSkin.XyPlane(-28, -44, 112, 14, 16, 16, 18, 8);
    //Bottom of ear
    //???
    //Left of ear (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -52, 108, 16, 18, 18, 20, 8);
    //Right of ear (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(-32, -44, 108, 12, 18, 14, 20, 8);
    //Front of ear
    Minecraft.PlayerSkin.XzPlane(-28, -56, 108, 14, 18, 16, 20, 8);
    //Back of ear
    Minecraft.PlayerSkin.xzPlane(-20, -40, 108, 18, 18, 20, 20, 8);
    popMatrix();
  }
  
  public void tailAS() {
    pushMatrix();
    translate(0, 70, 24);
    rotateX(-1*PI/3);
    translate(0, 0, -20);
//    //Old Left of Tail (Pony Perspective)
//    Minecraft.PlayerSkin.yZPlane(8, 4, 0, 32, 0, 34, 6, 8);
//    //Old Right of Tail (Pony Perspective)
//    Minecraft.PlayerSkin.yZPlane(-8, 4, 0, 32, 0, 34, 6, 8);
    //Left of Tail (Pony Perspective)
    Minecraft.PlayerSkin.ZYPlane(8, -4, 0, 32, 0, 38, 2, 8);
    //Right of Tail (Pony Perspective)
    Minecraft.PlayerSkin.ZYPlane(-8, -4, 0, 32, 0, 38, 2, 8);
//    //Old Top of Tail
//    Minecraft.PlayerSkin.xZPlane(4, -8, 0, 32, 0, 34, 6, 8);
    // Top of Tail
    Minecraft.PlayerSkin.xzPlane(4, -8, 40, 32, 0, 34, 6, 8);
    //Bottom of Tail
    Minecraft.PlayerSkin.xZPlane(4, 8, 0, 32, 0, 34, 6, 8);
    //Front of tail (Hidden)
    //(???)
//    //Old Back of Tail (End)
//    Minecraft.PlayerSkin.xyPlane(4, 4, 44, 32, 0, 34, 2, 8);
    //Back of Tail (End)
    Minecraft.PlayerSkin.xYPlane(4, -4, 44, 32, 0, 34, 2, 8);
    popMatrix();
  }
  
  public void tailSegment1() {
    //Left of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -24, 0, 36, 0, 40, 4, 8);
    //Right of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -24, 0, 36, 0, 40, 4, 8);
    //Back of Tail
    Minecraft.PlayerSkin.xzPlane(12, 4, 0, 32, 0, 36, 4, 8);
    //Front of Tail
    Minecraft.PlayerSkin.xzPlane(12, -28, 0, 32, 0, 36, 4, 8);
  }
  
  public void tailSegment2() {
    //Left of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -24, 0, 36, 4, 40, 8, 8);
    //Right of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -24, 0, 36, 4, 40, 8, 8);
    //Back of Tail
    Minecraft.PlayerSkin.xzPlane(12, 4, 0, 32, 4, 36, 8, 8);
    //Front of Tail
    Minecraft.PlayerSkin.xzPlane(12, -28, 0, 32, 4, 36, 8, 8);
  }
  
  public void snuzzleM() {
    pushMatrix();
    translate(0, -8, 16);
    //Top of snuzzle
    Minecraft.PlayerSkin.xyPlane(12, -100, 56, 10, 13, 14, 14, 8);
    //Bottom of snuzzle
    Minecraft.PlayerSkin.xyPlane(12, -100, 32, 10, 15, 14, 16, 8);
    //Right of snuzzle (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(16, -100, 52, 10, 13, 11, 16, 8);
    //Left of snuzzle (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(-16, -100, 52, 13, 13, 14, 16, 8);
    //Front of snuzzle
    Minecraft.PlayerSkin.xzPlane(12, -104, 52, 10, 13, 14, 16, 8);
    popMatrix();
  }
  
  public void snuzzleF() {
    pushMatrix();
    translate(0, -8, 16);
    //Right of snuzzle (Pony Perspective)
    //Top
    Minecraft.PlayerSkin.yzPlane(8, -100, 52, 11, 12, 12, 13, 8);
    //Bottom
    Minecraft.PlayerSkin.yzPlane(16, -100, 44, 9, 14, 10, 16, 8);
    //Left of snuzzle (Pony Perspective)
    //Top
    Minecraft.PlayerSkin.yzPlane(-8, -100, 52, 12, 12, 13, 13, 8);
    //Bottom
    Minecraft.PlayerSkin.yzPlane(-16, -100, 44, 14, 14, 15, 16, 8);
    //Top of snuzzle
    //Right (Pony Perspective)
    Minecraft.PlayerSkin.xyPlane(12, -100, 48, 9, 14, 10, 15, 8);
    //Middle
    Minecraft.PlayerSkin.xyPlane(4, -100, 56, 11, 12, 13, 13, 8);
    //Left (Pony Perspective)
    Minecraft.PlayerSkin.xyPlane(-12, -100, 48, 14, 14, 15, 15, 8);
    //Bottom of snuzzle
    Minecraft.PlayerSkin.xyPlane(12, -100, 32, 10, 15, 14, 16, 8);
    //Front of snuzzle
    //Top
    Minecraft.PlayerSkin.xzPlane(4, -104, 52, 11, 13, 13, 14, 8);
    //Bottom
    Minecraft.PlayerSkin.xzPlane(12, -104, 44, 10, 14, 14, 16, 8);
    popMatrix();
  }
  
  public void neck() {
    pushMatrix();
    translate(0, -60, 56);
    rotateX(PI/12);
    //Left of neck (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -8, -6, 0, 16, 4, 20, 8);
    //Rignt of neck (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -8, -6, 0, 16, 4, 20, 8);
    //Front of neck
    Minecraft.PlayerSkin.xzPlane(12, 20, -6, 0, 16, 4, 20, 8);
    //Back of neck
    Minecraft.PlayerSkin.xzPlane(12, -12, -6, 0, 16, 4, 20, 8);
    popMatrix();
  }
  
  public void legHLA() {
    //Top of leg
    Minecraft.PlayerSkin.XyPlane(-28, 44, -32, 4, 16, 8, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.XyPlane(-28, 44, -128, 8, 16, 12, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.XzPlane(-28, 16, -36, 4, 20, 8, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.xzPlane(-4, 48, -36, 12, 20, 16, 32, 8);
    //Left of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(-32, 44, -36, 0, 20, 4, 32, 8);
    //Right of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 8, 20, 12, 32, 8);
  }
  
  public void legHRA() {
    //Top of leg
    Minecraft.PlayerSkin.xyPlane(28, 44, -32, 4, 16, 8, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.xyPlane(28, 44, -128, 8, 16, 12, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.xzPlane(28, 16, -36, 4, 20, 8, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.XzPlane(4, 48, -36, 12, 20, 16, 32, 8);
    //Right of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(32, 44, -36, 0, 20, 4, 32, 8);
    //Left of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 8, 20, 12, 32, 8);
  }
  
  public void bodyA() {
    //Front of Pony (Chest)
      Minecraft.PlayerSkin.xzPlane(28, -64, 28, 20, 20, 28, 28, 8);
    //Back of pony (Flank)
      //Top
        Minecraft.PlayerSkin.xzPlane(28, 64, 28, 36, 16, 44, 20, 8);
      //Bottom
        Minecraft.PlayerSkin.xzPlane(28, 64, -4, 36, 16, 44, 20, 8);
    //Top of Body
      //Front (Withers)
      Minecraft.PlayerSkin.xyPlane(28, -36, 32, 20, 16, 28, 20, 8);
      //Back
      Minecraft.PlayerSkin.XYPlane(-28, -28, 32, 32, 20, 40, 32, 8);
    //Bottom of body
      //Front
        Minecraft.PlayerSkin.xyPlane(28, -36, -32, 28, 16, 36, 20, 8);
      //Middle (Barrel)
        Minecraft.PlayerSkin.xYPlane(28, -28, -32, 56, 0, 64, 8, 8);
      //Back
        Minecraft.PlayerSkin.xYPlane(28, 36, -32, 36, 16, 44, 20, 8);
    //Left side of Pony (Pony Perspective)
      //Left Shoulder
        Minecraft.PlayerSkin.YzPlane(-32, -60, 28, 28, 20, 32, 28, 8);
      //Middle
        Minecraft.PlayerSkin.YzPlane(-32, -28, 28, 24, 0, 32, 8, 8);
      //Back (Cutie Mark)
        Minecraft.PlayerSkin.YzPlane(-32, 36, 28, 4, 0, 8, 8, 8);
    //Right side of Pony (Pony Perspective)
      //Shoulder
        Minecraft.PlayerSkin.yzPlane(32, -36, 28, 16, 20, 20, 28, 8);
      //Middle
        Minecraft.PlayerSkin.YzPlane(32, -28, 28, 24, 0, 32, 8, 8);
      //Back (Right Cutie Mark)
        Minecraft.PlayerSkin.YzPlane(32, 36, 28, 4, 0, 8, 8, 8);
  }
  
  public void hornA() {
    pushMatrix();
    translate(0, -108, 120);
    rotateX(PI/6);
    //Tip of horn
    Minecraft.PlayerSkin.xyPlane(0, 0, 20, 1, 3, 2, 4, 8);
    //Front of horn
    Minecraft.PlayerSkin.xzPlane(0, -4, 16, 1, 4, 2, 8, 8);
    //Back of horn
    Minecraft.PlayerSkin.xzPlane(0, 4, 16, 3, 4, 4, 8, 8);
    //Left of Horn
    Minecraft.PlayerSkin.yzPlane(-4, 0, 16, 2, 4, 3, 8, 8);
    //Right of Horn
    Minecraft.PlayerSkin.yzPlane(4, 0, 16, 0, 4, 1, 8, 8);
    popMatrix();
  }
  
  public void LWing() {
    //Top of wing
    //Front
    Minecraft.PlayerSkin.xYPlane(-36, -28, 24, 62, 18, 64, 24, 8);
    //Back
    Minecraft.PlayerSkin.xYPlane(-36, 20, 8, 62, 24, 64, 26, 8);
    //Bottom of wing
    //Front
    Minecraft.PlayerSkin.XYPlane(-44, -28, -24, 58, 18, 60, 24, 8);
    //Back
    Minecraft.PlayerSkin.XYPlane(-44, 20, -8, 58, 24, 60, 26, 8);
    //Front of Wing
    //Top
    Minecraft.PlayerSkin.XzPlane(-44, -32, 20, 58, 16, 60, 18, 8);
    //Middle
    Minecraft.PlayerSkin.XzPlane(-44, -32, 4, 58, 16, 60, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.XzPlane(-44, -32, -12, 58, 16, 60, 18, 8);
    //Back of Wing
    //Top
    Minecraft.PlayerSkin.XzPlane(-44, 16, 20, 60, 16, 62, 18, 8);
    //Middle
    Minecraft.PlayerSkin.XzPlane(-44, 32, 4, 60, 16, 62, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.XzPlane(-44, 16, -12, 60, 16, 62, 18, 8);
    //Outside of Wing
    //Top
    Minecraft.PlayerSkin.zYPlane(-48, -28, 20, 56, 18, 58, 24, 8);
    //Middle
    Minecraft.PlayerSkin.zYPlane(-48, -28, 4, 56, 18, 58, 26, 8);
    //Bottom
    Minecraft.PlayerSkin.zYPlane(-48, -28, -12, 56, 18, 58, 24, 8);
  }
  
  public void RWing() {
    //Top of wing
    //Front
    Minecraft.PlayerSkin.XYPlane(36, -28, 24, 62, 18, 64, 24, 8);
    //Back
    Minecraft.PlayerSkin.XYPlane(36, 20, 8, 62, 24, 64, 26, 8);
    //Bottom of wing
    //Front
    Minecraft.PlayerSkin.xYPlane(44, -28, -24, 58, 18, 60, 24, 8);
    //Back
    Minecraft.PlayerSkin.xYPlane(44, 20, -8, 58, 24, 60, 26, 8);
    //Front of Wing
    //Top
    Minecraft.PlayerSkin.xzPlane(44, -32, 20, 58, 16, 60, 18, 8);
    //Middle
    Minecraft.PlayerSkin.xzPlane(44, -32, 4, 58, 16, 60, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.xzPlane(44, -32, -12, 58, 16, 60, 18, 8);
    //Back of Wing
    //Top
    Minecraft.PlayerSkin.xzPlane(44, 16, 20, 60, 16, 62, 18, 8);
    //Middle
    Minecraft.PlayerSkin.xzPlane(44, 32, 4, 60, 16, 62, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.xzPlane(44, 16, -12, 60, 16, 62, 18, 8);
    //Outside of Wing
    //Top
    Minecraft.PlayerSkin.zYPlane(48, -28, 20, 56, 18, 58, 24, 8);
    //Middle
    Minecraft.PlayerSkin.zYPlane(48, -28, 4, 56, 18, 58, 26, 8);
    //Bottom
    Minecraft.PlayerSkin.zYPlane(48, -28, -12, 56, 18, 58, 24, 8);
  }
  
  public void legFL() {
    //Top of leg
    Minecraft.PlayerSkin.XyPlane(-28, -28, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.XyPlane(-28, -28, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.XzPlane(-28, -56, -36, 44, 20, 48, 32, 8);  
    //Back of leg
    Minecraft.PlayerSkin.xzPlane(-4, -24, -36, 52, 20, 56, 32, 8);
    //Left of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(-32, -28, -36, 40, 20, 44, 32, 8);
    //Right of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, -52, -36, 48, 20, 52, 32, 8);
  }
  
  public void legHL() {
    //Top of leg
    Minecraft.PlayerSkin.XyPlane(-28, 44, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.XyPlane(-28, 44, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.XzPlane(-28, 16, -36, 44, 20, 48, 32, 8);  
    //Back of leg
    Minecraft.PlayerSkin.xzPlane(-4, 48, -36, 52, 20, 56, 32, 8);
    //Left of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(-32, 44, -36, 40, 20, 44, 32, 8);
    //Right of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 48, 20, 52, 32, 8);
  }
  
  public void legFR() {
    //Top of leg
    Minecraft.PlayerSkin.xyPlane(28, -28, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.xyPlane(28, -28, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.xzPlane(28, -56, -36, 44, 20, 48, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.XzPlane(4, -24, -36, 52, 20, 56, 32, 8);
    //Right of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(32, -28, -36, 40, 20, 44, 32, 8);
    //Left of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, -52, -36, 48, 20, 52, 32, 8);
  }
  
  public void legHR() {
    //Top of leg
    Minecraft.PlayerSkin.xyPlane(28, 44, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.xyPlane(28, 44, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.xzPlane(28, 16, -36, 44, 20, 48, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.XzPlane(4, 48, -36, 52, 20, 56, 32, 8);
    //Right of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(32, 44, -36, 40, 20, 44, 32, 8);
    //Left of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 48, 20, 52, 32, 8);
  }
  
  public void mane() {
    pushMatrix();
      translate(0, -8, 16);
      //Top of mane
      Minecraft.PlayerSkin.xyPlane(32, -33, 100, 40, 0, 48, 8, 9);
      //Bottom of mane
      Minecraft.PlayerSkin.xyPlane(32, -33, 29, 48, 0, 56, 8, 9);
      //Left of mane (Pony Perspective)
      Minecraft.PlayerSkin.YzPlane(-35, -96, 96, 48, 8, 56, 16, 9);
      //Right of mane (Pony Perspective)
      Minecraft.PlayerSkin.yzPlane(35, -33, 96, 32, 8, 40, 16, 9);
      //Front of mane
      Minecraft.PlayerSkin.xzPlane(32, -100, 96, 40, 8, 48, 16, 9);
      //Back of mane
      Minecraft.PlayerSkin.XzPlane(-31, -29, 96, 56, 8, 64, 16, 9);
    popMatrix();
  }
  
  public void head() {
    pushMatrix();
      translate(0, -8, 16);
      //Top of head
      Minecraft.PlayerSkin.xyPlane(28, -36, 96, 8, 0, 16, 8, 8);
      //Bottom of head
      Minecraft.PlayerSkin.xYPlane(28, -92, 32, 16, 0, 24, 8, 8);
      //Left of head
      Minecraft.PlayerSkin.YzPlane(-32, -92, 92, 16, 8, 24, 16, 8);
      //Right of head
      Minecraft.PlayerSkin.yzPlane(32, -36, 92, 0, 8, 8, 16, 8);
      //Front of head
      Minecraft.PlayerSkin.xzPlane(28, -96, 92, 8, 8, 16, 16, 8);
      //Back of head
      Minecraft.PlayerSkin.XzPlane(-28, -32, 92, 24, 8, 32, 16, 8);
    popMatrix();
  }
}
class MCPonyLarge{
  //Normal Pony Model
  MinecraftSkin Minecraft;
  MCPonyBase PonyBase;
    
  MCPonyLarge(MinecraftSkin Skin, MCPonyBase Base){
    Minecraft = Skin;
    PonyBase = Base;
    PonyBase.specialScan(Minecraft);
  }
  
  public void drawPony() {
    if(PonyBase.grid){
      strokeWeight(2);
      stroke(0, 0, 0, 255);
    }
    pushMatrix();
    translate(0, -16, 8);
    //Head
      if(PonyBase.show[0] == true){
        head();
      }
    //Ears
      if(PonyBase.show[1] == true){
        earLA();
        earRA();
      }
    //Snuzzle
      if(PonyBase.show[2] == true){
        if (PonyBase.male == 1) {
          snuzzleM();
        }
        else {
          snuzzleF();
        }
      }
    //Neck
      if(PonyBase.show[3] == true){
        neck();
      }
    //Mane
      if(PonyBase.show[9] == true){
        mane();
      }
    popMatrix();
    pushMatrix();
    scale(1.2f);
    //Body
      if(PonyBase.show[4] == true){
        bodyA();
      }
    //Left Legs
      if(PonyBase.show[5] == true){
        legFL();
        legHLA();
      }
    //Right Legs
      if(PonyBase.show[6] == true){
        legFR();
        legHRA();
      }
    //Tail 1
      if(PonyBase.show[7] == true){
        tailAS();
      }
    //Tail 2
      if(PonyBase.show[8] == true){
        tailAL();
      }
    popMatrix();
    //Magic
      switch(PonyBase.race) {
        case 1:
          //Earth Pony
          break;
        case 2:
          //Pegasus
            pushMatrix();
            scale(1.2f);
            //Left Wing
              if(PonyBase.show[10] == true){
                LWing();
              }
            //Right Wing
              if(PonyBase.show[11] == true){
                RWing();
              }
            popMatrix();
          break;
        case 3:
          //Unicorn
            pushMatrix();
            translate(0, -16, 8);
            //Horn
              if(PonyBase.show[12] == true){
                hornA();
              }
            popMatrix();
            break;
        case 4:
          //Alicorn
            pushMatrix();
            scale(1.2f);
            //Left Wing
              if(PonyBase.show[10] == true){
                LWing();
              }
            //Right Wing
              if(PonyBase.show[11] == true){
                RWing();
              }
            popMatrix();
            pushMatrix();
            translate(0, -16, 8);
            //Horn
              if(PonyBase.show[12] == true){
                hornA();
              }
            popMatrix();
            break;
        default:
          break;
      }
  }
  
  public void tailAL() {
    if (PonyBase.tailLength > 0) {
      pushMatrix();
      //Top of Tail
      Minecraft.PlayerSkin.xyPlane(12, 108, 48, 32, 0, 36, 4, 8);
      translate(0, 108, 44);
      //Tail Loop
      for (int i=0; i<PonyBase.tailLength; i++) {
        if (i%2 == 0) {
          tailSegment1();
        }
        else {
          tailSegment2();
        }
        translate(0, 0, -32);
      }
      //Bottom of Tail
      Minecraft.PlayerSkin.xyPlane(12, 0, 4, 32, 0, 36, 4, 8);
      popMatrix();
    }
  }
  
  public void earRA() {
    pushMatrix();
    translate(0, -8, 16);
    //Top of ear
    Minecraft.PlayerSkin.xyPlane(28, -44, 112, 14, 16, 16, 18, 8);
    //Bottom of ear
    //???
    //Left of ear (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -52, 108, 16, 18, 18, 20, 8);
    //Right of ear (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(32, -44, 108, 12, 18, 14, 20, 8);
    //Front of ear
    Minecraft.PlayerSkin.xzPlane(28, -56, 108, 14, 18, 16, 20, 8);
    //Back of ear
    Minecraft.PlayerSkin.XzPlane(20, -40, 108, 18, 18, 20, 20, 8);
    popMatrix();
  }
  
  public void earLA() {
    pushMatrix();
    translate(0, -8, 16);
    //Top of ear
    Minecraft.PlayerSkin.XyPlane(-28, -44, 112, 14, 16, 16, 18, 8);
    //Bottom of ear
    //???
    //Left of ear (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -52, 108, 16, 18, 18, 20, 8);
    //Right of ear (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(-32, -44, 108, 12, 18, 14, 20, 8);
    //Front of ear
    Minecraft.PlayerSkin.XzPlane(-28, -56, 108, 14, 18, 16, 20, 8);
    //Back of ear
    Minecraft.PlayerSkin.xzPlane(-20, -40, 108, 18, 18, 20, 20, 8);
    popMatrix();
  }
  
  public void tailAS() {
    pushMatrix();
    translate(0, 70, 24);
    rotateX(-1*PI/3);
    translate(0, 0, -20);
//    //Old Left of Tail (Pony Perspective)
//    Minecraft.PlayerSkin.yZPlane(8, 4, 0, 32, 0, 34, 6, 8);
//    //Old Right of Tail (Pony Perspective)
//    Minecraft.PlayerSkin.yZPlane(-8, 4, 0, 32, 0, 34, 6, 8);
    //Left of Tail (Pony Perspective)
    Minecraft.PlayerSkin.ZYPlane(8, -4, 0, 32, 0, 38, 2, 8);
    //Right of Tail (Pony Perspective)
    Minecraft.PlayerSkin.ZYPlane(-8, -4, 0, 32, 0, 38, 2, 8);
//    //Old Top of Tail
//    Minecraft.PlayerSkin.xZPlane(4, -8, 0, 32, 0, 34, 6, 8);
    // Top of Tail
    Minecraft.PlayerSkin.xzPlane(4, -8, 40, 32, 0, 34, 6, 8);
    //Bottom of Tail
    Minecraft.PlayerSkin.xZPlane(4, 8, 0, 32, 0, 34, 6, 8);
    //Front of tail (Hidden)
    //(???)
//    //Old Back of Tail (End)
//    Minecraft.PlayerSkin.xyPlane(4, 4, 44, 32, 0, 34, 2, 8);
    //Back of Tail (End)
    Minecraft.PlayerSkin.xYPlane(4, -4, 44, 32, 0, 34, 2, 8);
    popMatrix();
  }
  
  public void tailSegment1() {
    //Left of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -24, 0, 36, 0, 40, 4, 8);
    //Right of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -24, 0, 36, 0, 40, 4, 8);
    //Back of Tail
    Minecraft.PlayerSkin.xzPlane(12, 4, 0, 32, 0, 36, 4, 8);
    //Front of Tail
    Minecraft.PlayerSkin.xzPlane(12, -28, 0, 32, 0, 36, 4, 8);
  }
  
  public void tailSegment2() {
    //Left of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -24, 0, 36, 4, 40, 8, 8);
    //Right of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -24, 0, 36, 4, 40, 8, 8);
    //Back of Tail
    Minecraft.PlayerSkin.xzPlane(12, 4, 0, 32, 4, 36, 8, 8);
    //Front of Tail
    Minecraft.PlayerSkin.xzPlane(12, -28, 0, 32, 4, 36, 8, 8);
  }
  
  public void snuzzleM() {
    pushMatrix();
    translate(0, -8, 16);
    //Top of snuzzle
    Minecraft.PlayerSkin.xyPlane(12, -100, 56, 10, 13, 14, 14, 8);
    //Bottom of snuzzle
    Minecraft.PlayerSkin.xyPlane(12, -100, 32, 10, 15, 14, 16, 8);
    //Right of snuzzle (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(16, -100, 52, 10, 13, 11, 16, 8);
    //Left of snuzzle (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(-16, -100, 52, 13, 13, 14, 16, 8);
    //Front of snuzzle
    Minecraft.PlayerSkin.xzPlane(12, -104, 52, 10, 13, 14, 16, 8);
    popMatrix();
  }
  
  public void snuzzleF() {
    pushMatrix();
    translate(0, -8, 16);
    //Right of snuzzle (Pony Perspective)
    //Top
    Minecraft.PlayerSkin.yzPlane(8, -100, 52, 11, 12, 12, 13, 8);
    //Bottom
    Minecraft.PlayerSkin.yzPlane(16, -100, 44, 9, 14, 10, 16, 8);
    //Left of snuzzle (Pony Perspective)
    //Top
    Minecraft.PlayerSkin.yzPlane(-8, -100, 52, 12, 12, 13, 13, 8);
    //Bottom
    Minecraft.PlayerSkin.yzPlane(-16, -100, 44, 14, 14, 15, 16, 8);
    //Top of snuzzle
    //Right (Pony Perspective)
    Minecraft.PlayerSkin.xyPlane(12, -100, 48, 9, 14, 10, 15, 8);
    //Middle
    Minecraft.PlayerSkin.xyPlane(4, -100, 56, 11, 12, 13, 13, 8);
    //Left (Pony Perspective)
    Minecraft.PlayerSkin.xyPlane(-12, -100, 48, 14, 14, 15, 15, 8);
    //Bottom of snuzzle
    Minecraft.PlayerSkin.xyPlane(12, -100, 32, 10, 15, 14, 16, 8);
    //Front of snuzzle
    //Top
    Minecraft.PlayerSkin.xzPlane(4, -104, 52, 11, 13, 13, 14, 8);
    //Bottom
    Minecraft.PlayerSkin.xzPlane(12, -104, 44, 10, 14, 14, 16, 8);
    popMatrix();
  }
  
  public void neck() {
    pushMatrix();
    translate(0, -60, 56);
    rotateX(PI/12);
    //Left of neck (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -8, -6, 0, 16, 4, 20, 8);
    //Rignt of neck (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -8, -6, 0, 16, 4, 20, 8);
    //Front of neck
    Minecraft.PlayerSkin.xzPlane(12, 20, -6, 0, 16, 4, 20, 8);
    //Back of neck
    Minecraft.PlayerSkin.xzPlane(12, -12, -6, 0, 16, 4, 20, 8);
    popMatrix();
  }
  
  public void legHLA() {
    //Top of leg
    Minecraft.PlayerSkin.XyPlane(-28, 44, -32, 4, 16, 8, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.XyPlane(-28, 44, -128, 8, 16, 12, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.XzPlane(-28, 16, -36, 4, 20, 8, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.xzPlane(-4, 48, -36, 12, 20, 16, 32, 8);
    //Left of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(-32, 44, -36, 0, 20, 4, 32, 8);
    //Right of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 8, 20, 12, 32, 8);
  }
  
  public void legHRA() {
    //Top of leg
    Minecraft.PlayerSkin.xyPlane(28, 44, -32, 4, 16, 8, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.xyPlane(28, 44, -128, 8, 16, 12, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.xzPlane(28, 16, -36, 4, 20, 8, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.XzPlane(4, 48, -36, 12, 20, 16, 32, 8);
    //Right of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(32, 44, -36, 0, 20, 4, 32, 8);
    //Left of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 8, 20, 12, 32, 8);
  }
  
  public void bodyA() {
    //Front of Pony (Chest)
      Minecraft.PlayerSkin.xzPlane(28, -64, 28, 20, 20, 28, 28, 8);
    //Back of pony (Flank)
      //Top
        Minecraft.PlayerSkin.xzPlane(28, 64, 28, 36, 16, 44, 20, 8);
      //Bottom
        Minecraft.PlayerSkin.xzPlane(28, 64, -4, 36, 16, 44, 20, 8);
    //Top of Body
      //Front (Withers)
      Minecraft.PlayerSkin.xyPlane(28, -36, 32, 20, 16, 28, 20, 8);
      //Back
      Minecraft.PlayerSkin.XYPlane(-28, -28, 32, 32, 20, 40, 32, 8);
    //Bottom of body
      //Front
        Minecraft.PlayerSkin.xyPlane(28, -36, -32, 28, 16, 36, 20, 8);
      //Middle (Barrel)
        Minecraft.PlayerSkin.xYPlane(28, -28, -32, 56, 0, 64, 8, 8);
      //Back
        Minecraft.PlayerSkin.xYPlane(28, 36, -32, 36, 16, 44, 20, 8);
    //Left side of Pony (Pony Perspective)
      //Left Shoulder
        Minecraft.PlayerSkin.YzPlane(-32, -60, 28, 28, 20, 32, 28, 8);
      //Middle
        Minecraft.PlayerSkin.YzPlane(-32, -28, 28, 24, 0, 32, 8, 8);
      //Back (Cutie Mark)
        Minecraft.PlayerSkin.YzPlane(-32, 36, 28, 4, 0, 8, 8, 8);
    //Right side of Pony (Pony Perspective)
      //Shoulder
        Minecraft.PlayerSkin.yzPlane(32, -36, 28, 16, 20, 20, 28, 8);
      //Middle
        Minecraft.PlayerSkin.YzPlane(32, -28, 28, 24, 0, 32, 8, 8);
      //Back (Right Cutie Mark)
        Minecraft.PlayerSkin.YzPlane(32, 36, 28, 4, 0, 8, 8, 8);
  }
  
  public void hornA() {
    pushMatrix();
    translate(0, -108, 120);
    rotateX(PI/6);
    //Tip of horn
    Minecraft.PlayerSkin.xyPlane(0, 0, 20, 1, 3, 2, 4, 8);
    //Front of horn
    Minecraft.PlayerSkin.xzPlane(0, -4, 16, 1, 4, 2, 8, 8);
    //Back of horn
    Minecraft.PlayerSkin.xzPlane(0, 4, 16, 3, 4, 4, 8, 8);
    //Left of Horn
    Minecraft.PlayerSkin.yzPlane(-4, 0, 16, 2, 4, 3, 8, 8);
    //Right of Horn
    Minecraft.PlayerSkin.yzPlane(4, 0, 16, 0, 4, 1, 8, 8);
    popMatrix();
  }
  
  public void LWing() {
    //Top of wing
    //Front
    Minecraft.PlayerSkin.xYPlane(-36, -28, 24, 62, 18, 64, 24, 8);
    //Back
    Minecraft.PlayerSkin.xYPlane(-36, 20, 8, 62, 24, 64, 26, 8);
    //Bottom of wing
    //Front
    Minecraft.PlayerSkin.XYPlane(-44, -28, -24, 58, 18, 60, 24, 8);
    //Back
    Minecraft.PlayerSkin.XYPlane(-44, 20, -8, 58, 24, 60, 26, 8);
    //Front of Wing
    //Top
    Minecraft.PlayerSkin.XzPlane(-44, -32, 20, 58, 16, 60, 18, 8);
    //Middle
    Minecraft.PlayerSkin.XzPlane(-44, -32, 4, 58, 16, 60, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.XzPlane(-44, -32, -12, 58, 16, 60, 18, 8);
    //Back of Wing
    //Top
    Minecraft.PlayerSkin.XzPlane(-44, 16, 20, 60, 16, 62, 18, 8);
    //Middle
    Minecraft.PlayerSkin.XzPlane(-44, 32, 4, 60, 16, 62, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.XzPlane(-44, 16, -12, 60, 16, 62, 18, 8);
    //Outside of Wing
    //Top
    Minecraft.PlayerSkin.zYPlane(-48, -28, 20, 56, 18, 58, 24, 8);
    //Middle
    Minecraft.PlayerSkin.zYPlane(-48, -28, 4, 56, 18, 58, 26, 8);
    //Bottom
    Minecraft.PlayerSkin.zYPlane(-48, -28, -12, 56, 18, 58, 24, 8);
  }
  
  public void RWing() {
    //Top of wing
    //Front
    Minecraft.PlayerSkin.XYPlane(36, -28, 24, 62, 18, 64, 24, 8);
    //Back
    Minecraft.PlayerSkin.XYPlane(36, 20, 8, 62, 24, 64, 26, 8);
    //Bottom of wing
    //Front
    Minecraft.PlayerSkin.xYPlane(44, -28, -24, 58, 18, 60, 24, 8);
    //Back
    Minecraft.PlayerSkin.xYPlane(44, 20, -8, 58, 24, 60, 26, 8);
    //Front of Wing
    //Top
    Minecraft.PlayerSkin.xzPlane(44, -32, 20, 58, 16, 60, 18, 8);
    //Middle
    Minecraft.PlayerSkin.xzPlane(44, -32, 4, 58, 16, 60, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.xzPlane(44, -32, -12, 58, 16, 60, 18, 8);
    //Back of Wing
    //Top
    Minecraft.PlayerSkin.xzPlane(44, 16, 20, 60, 16, 62, 18, 8);
    //Middle
    Minecraft.PlayerSkin.xzPlane(44, 32, 4, 60, 16, 62, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.xzPlane(44, 16, -12, 60, 16, 62, 18, 8);
    //Outside of Wing
    //Top
    Minecraft.PlayerSkin.zYPlane(48, -28, 20, 56, 18, 58, 24, 8);
    //Middle
    Minecraft.PlayerSkin.zYPlane(48, -28, 4, 56, 18, 58, 26, 8);
    //Bottom
    Minecraft.PlayerSkin.zYPlane(48, -28, -12, 56, 18, 58, 24, 8);
  }
  
  public void legFL() {
    //Top of leg
    Minecraft.PlayerSkin.XyPlane(-28, -28, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.XyPlane(-28, -28, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.XzPlane(-28, -56, -36, 44, 20, 48, 32, 8);  
    //Back of leg
    Minecraft.PlayerSkin.xzPlane(-4, -24, -36, 52, 20, 56, 32, 8);
    //Left of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(-32, -28, -36, 40, 20, 44, 32, 8);
    //Right of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, -52, -36, 48, 20, 52, 32, 8);
  }
  
  public void legHL() {
    //Top of leg
    Minecraft.PlayerSkin.XyPlane(-28, 44, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.XyPlane(-28, 44, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.XzPlane(-28, 16, -36, 44, 20, 48, 32, 8);  
    //Back of leg
    Minecraft.PlayerSkin.xzPlane(-4, 48, -36, 52, 20, 56, 32, 8);
    //Left of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(-32, 44, -36, 40, 20, 44, 32, 8);
    //Right of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 48, 20, 52, 32, 8);
  }
  
  public void legFR() {
    //Top of leg
    Minecraft.PlayerSkin.xyPlane(28, -28, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.xyPlane(28, -28, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.xzPlane(28, -56, -36, 44, 20, 48, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.XzPlane(4, -24, -36, 52, 20, 56, 32, 8);
    //Right of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(32, -28, -36, 40, 20, 44, 32, 8);
    //Left of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, -52, -36, 48, 20, 52, 32, 8);
  }
  
  public void legHR() {
    //Top of leg
    Minecraft.PlayerSkin.xyPlane(28, 44, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.xyPlane(28, 44, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.xzPlane(28, 16, -36, 44, 20, 48, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.XzPlane(4, 48, -36, 52, 20, 56, 32, 8);
    //Right of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(32, 44, -36, 40, 20, 44, 32, 8);
    //Left of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 48, 20, 52, 32, 8);
  }
  
  public void mane() {
    pushMatrix();
      translate(0, -8, 16);
      //Top of mane
      Minecraft.PlayerSkin.xyPlane(32, -33, 100, 40, 0, 48, 8, 9);
      //Bottom of mane
      Minecraft.PlayerSkin.xyPlane(32, -33, 29, 48, 0, 56, 8, 9);
      //Left of mane (Pony Perspective)
      Minecraft.PlayerSkin.YzPlane(-35, -96, 96, 48, 8, 56, 16, 9);
      //Right of mane (Pony Perspective)
      Minecraft.PlayerSkin.yzPlane(35, -33, 96, 32, 8, 40, 16, 9);
      //Front of mane
      Minecraft.PlayerSkin.xzPlane(32, -100, 96, 40, 8, 48, 16, 9);
      //Back of mane
      Minecraft.PlayerSkin.XzPlane(-31, -29, 96, 56, 8, 64, 16, 9);
    popMatrix();
  }
  
  public void head() {
    pushMatrix();
      translate(0, -8, 16);
      //Top of head
      Minecraft.PlayerSkin.xyPlane(28, -36, 96, 8, 0, 16, 8, 8);
      //Bottom of head
      Minecraft.PlayerSkin.xYPlane(28, -92, 32, 16, 0, 24, 8, 8);
      //Left of head
      Minecraft.PlayerSkin.YzPlane(-32, -92, 92, 16, 8, 24, 16, 8);
      //Right of head
      Minecraft.PlayerSkin.yzPlane(32, -36, 92, 0, 8, 8, 16, 8);
      //Front of head
      Minecraft.PlayerSkin.xzPlane(28, -96, 92, 8, 8, 16, 16, 8);
      //Back of head
      Minecraft.PlayerSkin.XzPlane(-28, -32, 92, 24, 8, 32, 16, 8);
    popMatrix();
  }
}
class MCPonyAlicorn{
  //Normal Pony Model
  MinecraftSkin Minecraft;
  MCPonyBase PonyBase;
    
  MCPonyAlicorn(MinecraftSkin Skin, MCPonyBase Base){
    Minecraft = Skin;
    PonyBase = Base;
    PonyBase.specialScan(Minecraft);
  }
  
  public void drawPony() {
    if(PonyBase.grid){
      strokeWeight(2);
      stroke(0, 0, 0, 255);
    }
    //Head
      if(PonyBase.show[0] == true){
        head();
      }
    //Ears
      if(PonyBase.show[1] == true){
        earLA();
        earRA();
      }
    //Snuzzle
      if(PonyBase.show[2] == true){
        if (PonyBase.male == 1) {
          snuzzleM();
        }
        else {
          snuzzleF();
        }
      }
    //Neck
      if(PonyBase.show[3] == true){
        neck();
      }
    //Mane
      if(PonyBase.show[9] == true){
        mane();
      }
    //Body
      if(PonyBase.show[4] == true){
        bodyA();
      }
    //Tail 1
      if(PonyBase.show[7] == true){
        tailAS();
      }
    //Tail 2
      if(PonyBase.show[8] == true){
        tailAL();
      }
    pushMatrix();
    scale(1, 1, 1.2f);
    translate(0, 0, 6);
    //Left Legs
      if(PonyBase.show[5] == true){
        pushMatrix();
        rotateZ(-PI/24);
        legFL();
        rotateZ(PI/12);
        legHLA();
        popMatrix();
      }
    //Right Legs
      if(PonyBase.show[6] == true){
        pushMatrix();
        rotateZ(-PI/24);
        legFR();
        rotateZ(PI/12);
        legHRA();
        popMatrix();
      }
    popMatrix();
    //Magic
      switch(PonyBase.race) {
        case 1:
          //Earth Pony
          break;
        case 2:
          //Pegasus
            //Left Wing
              if(PonyBase.show[10] == true){
                LWing();
              }
            //Right Wing
              if(PonyBase.show[11] == true){
                RWing();
              }
          break;
        case 3:
          //Unicorn
            //Horn
              if(PonyBase.show[12] == true){
                hornA();
              }
            break;
        case 4:
          //Alicorn
            //Left Wing
              if(PonyBase.show[10] == true){
                LWing();
              }
            //Right Wing
              if(PonyBase.show[11] == true){
                RWing();
              }
            //Horn
              if(PonyBase.show[12] == true){
                hornA();
              }
            break;
        default:
          break;
      }
  }
  
  public void tailAL() {
    if (PonyBase.tailLength > 0) {
      pushMatrix();
      //Top of Tail
      Minecraft.PlayerSkin.xyPlane(12, 108, 48, 32, 0, 36, 4, 8);
      translate(0, 108, 44);
      //Tail Loop
      for (int i=0; i<PonyBase.tailLength; i++) {
        if (i%2 == 0) {
          tailSegment1();
        }
        else {
          tailSegment2();
        }
        translate(0, 0, -32);
      }
      //Bottom of Tail
      Minecraft.PlayerSkin.xyPlane(12, 0, 4, 32, 0, 36, 4, 8);
      popMatrix();
    }
  }
  
  public void earRA() {
    pushMatrix();
    translate(0, -8, 16);
    //Top of ear
    Minecraft.PlayerSkin.xyPlane(28, -44, 112, 14, 16, 16, 18, 8);
    //Bottom of ear
    //???
    //Left of ear (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -52, 108, 16, 18, 18, 20, 8);
    //Right of ear (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(32, -44, 108, 12, 18, 14, 20, 8);
    //Front of ear
    Minecraft.PlayerSkin.xzPlane(28, -56, 108, 14, 18, 16, 20, 8);
    //Back of ear
    Minecraft.PlayerSkin.XzPlane(20, -40, 108, 18, 18, 20, 20, 8);
    popMatrix();
  }
  
  public void earLA() {
    pushMatrix();
    translate(0, -8, 16);
    //Top of ear
    Minecraft.PlayerSkin.XyPlane(-28, -44, 112, 14, 16, 16, 18, 8);
    //Bottom of ear
    //???
    //Left of ear (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -52, 108, 16, 18, 18, 20, 8);
    //Right of ear (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(-32, -44, 108, 12, 18, 14, 20, 8);
    //Front of ear
    Minecraft.PlayerSkin.XzPlane(-28, -56, 108, 14, 18, 16, 20, 8);
    //Back of ear
    Minecraft.PlayerSkin.xzPlane(-20, -40, 108, 18, 18, 20, 20, 8);
    popMatrix();
  }
  
  public void tailAS() {
    pushMatrix();
    translate(0, 70, 24);
    rotateX(-1*PI/3);
    translate(0, 0, -20);
//    //Old Left of Tail (Pony Perspective)
//    Minecraft.PlayerSkin.yZPlane(8, 4, 0, 32, 0, 34, 6, 8);
//    //Old Right of Tail (Pony Perspective)
//    Minecraft.PlayerSkin.yZPlane(-8, 4, 0, 32, 0, 34, 6, 8);
    //Left of Tail (Pony Perspective)
    Minecraft.PlayerSkin.ZYPlane(8, -4, 0, 32, 0, 38, 2, 8);
    //Right of Tail (Pony Perspective)
    Minecraft.PlayerSkin.ZYPlane(-8, -4, 0, 32, 0, 38, 2, 8);
//    //Old Top of Tail
//    Minecraft.PlayerSkin.xZPlane(4, -8, 0, 32, 0, 34, 6, 8);
    // Top of Tail
    Minecraft.PlayerSkin.xzPlane(4, -8, 40, 32, 0, 34, 6, 8);
    //Bottom of Tail
    Minecraft.PlayerSkin.xZPlane(4, 8, 0, 32, 0, 34, 6, 8);
    //Front of tail (Hidden)
    //(???)
//    //Old Back of Tail (End)
//    Minecraft.PlayerSkin.xyPlane(4, 4, 44, 32, 0, 34, 2, 8);
    //Back of Tail (End)
    Minecraft.PlayerSkin.xYPlane(4, -4, 44, 32, 0, 34, 2, 8);
    popMatrix();
  }
  
  public void tailSegment1() {
    //Left of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -24, 0, 36, 0, 40, 4, 8);
    //Right of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -24, 0, 36, 0, 40, 4, 8);
    //Back of Tail
    Minecraft.PlayerSkin.xzPlane(12, 4, 0, 32, 0, 36, 4, 8);
    //Front of Tail
    Minecraft.PlayerSkin.xzPlane(12, -28, 0, 32, 0, 36, 4, 8);
  }
  
  public void tailSegment2() {
    //Left of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -24, 0, 36, 4, 40, 8, 8);
    //Right of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -24, 0, 36, 4, 40, 8, 8);
    //Back of Tail
    Minecraft.PlayerSkin.xzPlane(12, 4, 0, 32, 4, 36, 8, 8);
    //Front of Tail
    Minecraft.PlayerSkin.xzPlane(12, -28, 0, 32, 4, 36, 8, 8);
  }
  
  public void snuzzleM() {
    pushMatrix();
    translate(0, -8, 16);
    //Top of snuzzle
    Minecraft.PlayerSkin.xyPlane(12, -100, 56, 10, 13, 14, 14, 8);
    //Bottom of snuzzle
    Minecraft.PlayerSkin.xyPlane(12, -100, 32, 10, 15, 14, 16, 8);
    //Right of snuzzle (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(16, -100, 52, 10, 13, 11, 16, 8);
    //Left of snuzzle (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(-16, -100, 52, 13, 13, 14, 16, 8);
    //Front of snuzzle
    Minecraft.PlayerSkin.xzPlane(12, -104, 52, 10, 13, 14, 16, 8);
    popMatrix();
  }
  
  public void snuzzleF() {
    pushMatrix();
    translate(0, -8, 16);
    //Right of snuzzle (Pony Perspective)
    //Top
    Minecraft.PlayerSkin.yzPlane(8, -100, 52, 11, 12, 12, 13, 8);
    //Bottom
    Minecraft.PlayerSkin.yzPlane(16, -100, 44, 9, 14, 10, 16, 8);
    //Left of snuzzle (Pony Perspective)
    //Top
    Minecraft.PlayerSkin.yzPlane(-8, -100, 52, 12, 12, 13, 13, 8);
    //Bottom
    Minecraft.PlayerSkin.yzPlane(-16, -100, 44, 14, 14, 15, 16, 8);
    //Top of snuzzle
    //Right (Pony Perspective)
    Minecraft.PlayerSkin.xyPlane(12, -100, 48, 9, 14, 10, 15, 8);
    //Middle
    Minecraft.PlayerSkin.xyPlane(4, -100, 56, 11, 12, 13, 13, 8);
    //Left (Pony Perspective)
    Minecraft.PlayerSkin.xyPlane(-12, -100, 48, 14, 14, 15, 15, 8);
    //Bottom of snuzzle
    Minecraft.PlayerSkin.xyPlane(12, -100, 32, 10, 15, 14, 16, 8);
    //Front of snuzzle
    //Top
    Minecraft.PlayerSkin.xzPlane(4, -104, 52, 11, 13, 13, 14, 8);
    //Bottom
    Minecraft.PlayerSkin.xzPlane(12, -104, 44, 10, 14, 14, 16, 8);
    popMatrix();
  }
  
  public void neck() {
    pushMatrix();
    translate(0, -60, 56);
    rotateX(PI/12);
    //Left of neck (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -8, -6, 0, 16, 4, 20, 8);
    //Rignt of neck (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -8, -6, 0, 16, 4, 20, 8);
    //Front of neck
    Minecraft.PlayerSkin.xzPlane(12, 20, -6, 0, 16, 4, 20, 8);
    //Back of neck
    Minecraft.PlayerSkin.xzPlane(12, -12, -6, 0, 16, 4, 20, 8);
    popMatrix();
  }
  
  public void legHLA() {
    //Top of leg
    Minecraft.PlayerSkin.XyPlane(-28, 44, -32, 4, 16, 8, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.XyPlane(-28, 44, -128, 8, 16, 12, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.XzPlane(-28, 16, -36, 4, 20, 8, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.xzPlane(-4, 48, -36, 12, 20, 16, 32, 8);
    //Left of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(-32, 44, -36, 0, 20, 4, 32, 8);
    //Right of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 8, 20, 12, 32, 8);
  }
  
  public void legHRA() {
    //Top of leg
    Minecraft.PlayerSkin.xyPlane(28, 44, -32, 4, 16, 8, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.xyPlane(28, 44, -128, 8, 16, 12, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.xzPlane(28, 16, -36, 4, 20, 8, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.XzPlane(4, 48, -36, 12, 20, 16, 32, 8);
    //Right of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(32, 44, -36, 0, 20, 4, 32, 8);
    //Left of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 8, 20, 12, 32, 8);
  }
  
  public void bodyA() {
    //Front of Pony (Chest)
      Minecraft.PlayerSkin.xzPlane(28, -64, 28, 20, 20, 28, 28, 8);
    //Back of pony (Flank)
      //Top
        Minecraft.PlayerSkin.xzPlane(28, 64, 28, 36, 16, 44, 20, 8);
      //Bottom
        Minecraft.PlayerSkin.xzPlane(28, 64, -4, 36, 16, 44, 20, 8);
    //Top of Body
      //Front (Withers)
      Minecraft.PlayerSkin.xyPlane(28, -36, 32, 20, 16, 28, 20, 8);
      //Back
      Minecraft.PlayerSkin.XYPlane(-28, -28, 32, 32, 20, 40, 32, 8);
    //Bottom of body
      //Front
        Minecraft.PlayerSkin.xyPlane(28, -36, -32, 28, 16, 36, 20, 8);
      //Middle (Barrel)
        Minecraft.PlayerSkin.xYPlane(28, -28, -32, 56, 0, 64, 8, 8);
      //Back
        Minecraft.PlayerSkin.xYPlane(28, 36, -32, 36, 16, 44, 20, 8);
    //Left side of Pony (Pony Perspective)
      //Left Shoulder
        Minecraft.PlayerSkin.YzPlane(-32, -60, 28, 28, 20, 32, 28, 8);
      //Middle
        Minecraft.PlayerSkin.YzPlane(-32, -28, 28, 24, 0, 32, 8, 8);
      //Back (Cutie Mark)
        Minecraft.PlayerSkin.YzPlane(-32, 36, 28, 4, 0, 8, 8, 8);
    //Right side of Pony (Pony Perspective)
      //Shoulder
        Minecraft.PlayerSkin.yzPlane(32, -36, 28, 16, 20, 20, 28, 8);
      //Middle
        Minecraft.PlayerSkin.YzPlane(32, -28, 28, 24, 0, 32, 8, 8);
      //Back (Right Cutie Mark)
        Minecraft.PlayerSkin.YzPlane(32, 36, 28, 4, 0, 8, 8, 8);
  }
  
  public void hornA() {
    pushMatrix();
    translate(0, -108, 120);
    rotateX(PI/6);
    //Tip of horn
    Minecraft.PlayerSkin.xyPlane(0, 0, 20, 1, 3, 2, 4, 8);
    //Front of horn
    Minecraft.PlayerSkin.xzPlane(0, -4, 16, 1, 4, 2, 8, 8);
    //Back of horn
    Minecraft.PlayerSkin.xzPlane(0, 4, 16, 3, 4, 4, 8, 8);
    //Left of Horn
    Minecraft.PlayerSkin.yzPlane(-4, 0, 16, 2, 4, 3, 8, 8);
    //Right of Horn
    Minecraft.PlayerSkin.yzPlane(4, 0, 16, 0, 4, 1, 8, 8);
    popMatrix();
  }
  
  public void LWing() {
    //Top of wing
    //Front
    Minecraft.PlayerSkin.xYPlane(-36, -28, 24, 62, 18, 64, 24, 8);
    //Back
    Minecraft.PlayerSkin.xYPlane(-36, 20, 8, 62, 24, 64, 26, 8);
    //Bottom of wing
    //Front
    Minecraft.PlayerSkin.XYPlane(-44, -28, -24, 58, 18, 60, 24, 8);
    //Back
    Minecraft.PlayerSkin.XYPlane(-44, 20, -8, 58, 24, 60, 26, 8);
    //Front of Wing
    //Top
    Minecraft.PlayerSkin.XzPlane(-44, -32, 20, 58, 16, 60, 18, 8);
    //Middle
    Minecraft.PlayerSkin.XzPlane(-44, -32, 4, 58, 16, 60, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.XzPlane(-44, -32, -12, 58, 16, 60, 18, 8);
    //Back of Wing
    //Top
    Minecraft.PlayerSkin.XzPlane(-44, 16, 20, 60, 16, 62, 18, 8);
    //Middle
    Minecraft.PlayerSkin.XzPlane(-44, 32, 4, 60, 16, 62, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.XzPlane(-44, 16, -12, 60, 16, 62, 18, 8);
    //Outside of Wing
    //Top
    Minecraft.PlayerSkin.zYPlane(-48, -28, 20, 56, 18, 58, 24, 8);
    //Middle
    Minecraft.PlayerSkin.zYPlane(-48, -28, 4, 56, 18, 58, 26, 8);
    //Bottom
    Minecraft.PlayerSkin.zYPlane(-48, -28, -12, 56, 18, 58, 24, 8);
  }
  
  public void RWing() {
    //Top of wing
    //Front
    Minecraft.PlayerSkin.XYPlane(36, -28, 24, 62, 18, 64, 24, 8);
    //Back
    Minecraft.PlayerSkin.XYPlane(36, 20, 8, 62, 24, 64, 26, 8);
    //Bottom of wing
    //Front
    Minecraft.PlayerSkin.xYPlane(44, -28, -24, 58, 18, 60, 24, 8);
    //Back
    Minecraft.PlayerSkin.xYPlane(44, 20, -8, 58, 24, 60, 26, 8);
    //Front of Wing
    //Top
    Minecraft.PlayerSkin.xzPlane(44, -32, 20, 58, 16, 60, 18, 8);
    //Middle
    Minecraft.PlayerSkin.xzPlane(44, -32, 4, 58, 16, 60, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.xzPlane(44, -32, -12, 58, 16, 60, 18, 8);
    //Back of Wing
    //Top
    Minecraft.PlayerSkin.xzPlane(44, 16, 20, 60, 16, 62, 18, 8);
    //Middle
    Minecraft.PlayerSkin.xzPlane(44, 32, 4, 60, 16, 62, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.xzPlane(44, 16, -12, 60, 16, 62, 18, 8);
    //Outside of Wing
    //Top
    Minecraft.PlayerSkin.zYPlane(48, -28, 20, 56, 18, 58, 24, 8);
    //Middle
    Minecraft.PlayerSkin.zYPlane(48, -28, 4, 56, 18, 58, 26, 8);
    //Bottom
    Minecraft.PlayerSkin.zYPlane(48, -28, -12, 56, 18, 58, 24, 8);
  }
  
  public void legFL() {
    //Top of leg
    Minecraft.PlayerSkin.XyPlane(-28, -28, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.XyPlane(-28, -28, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.XzPlane(-28, -56, -36, 44, 20, 48, 32, 8);  
    //Back of leg
    Minecraft.PlayerSkin.xzPlane(-4, -24, -36, 52, 20, 56, 32, 8);
    //Left of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(-32, -28, -36, 40, 20, 44, 32, 8);
    //Right of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, -52, -36, 48, 20, 52, 32, 8);
  }
  
  public void legHL() {
    //Top of leg
    Minecraft.PlayerSkin.XyPlane(-28, 44, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.XyPlane(-28, 44, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.XzPlane(-28, 16, -36, 44, 20, 48, 32, 8);  
    //Back of leg
    Minecraft.PlayerSkin.xzPlane(-4, 48, -36, 52, 20, 56, 32, 8);
    //Left of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(-32, 44, -36, 40, 20, 44, 32, 8);
    //Right of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 48, 20, 52, 32, 8);
  }
  
  public void legFR() {
    //Top of leg
    Minecraft.PlayerSkin.xyPlane(28, -28, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.xyPlane(28, -28, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.xzPlane(28, -56, -36, 44, 20, 48, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.XzPlane(4, -24, -36, 52, 20, 56, 32, 8);
    //Right of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(32, -28, -36, 40, 20, 44, 32, 8);
    //Left of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, -52, -36, 48, 20, 52, 32, 8);
  }
  
  public void legHR() {
    //Top of leg
    Minecraft.PlayerSkin.xyPlane(28, 44, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.xyPlane(28, 44, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.xzPlane(28, 16, -36, 44, 20, 48, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.XzPlane(4, 48, -36, 52, 20, 56, 32, 8);
    //Right of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(32, 44, -36, 40, 20, 44, 32, 8);
    //Left of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 48, 20, 52, 32, 8);
  }
  
  public void mane() {
    pushMatrix();
      translate(0, -8, 16);
      //Top of mane
      Minecraft.PlayerSkin.xyPlane(32, -33, 100, 40, 0, 48, 8, 9);
      //Bottom of mane
      Minecraft.PlayerSkin.xyPlane(32, -33, 29, 48, 0, 56, 8, 9);
      //Left of mane (Pony Perspective)
      Minecraft.PlayerSkin.YzPlane(-35, -96, 96, 48, 8, 56, 16, 9);
      //Right of mane (Pony Perspective)
      Minecraft.PlayerSkin.yzPlane(35, -33, 96, 32, 8, 40, 16, 9);
      //Front of mane
      Minecraft.PlayerSkin.xzPlane(32, -100, 96, 40, 8, 48, 16, 9);
      //Back of mane
      Minecraft.PlayerSkin.XzPlane(-31, -29, 96, 56, 8, 64, 16, 9);
    popMatrix();
  }
  
  public void head() {
    pushMatrix();
      translate(0, -8, 16);
      //Top of head
      Minecraft.PlayerSkin.xyPlane(28, -36, 96, 8, 0, 16, 8, 8);
      //Bottom of head
      Minecraft.PlayerSkin.xYPlane(28, -92, 32, 16, 0, 24, 8, 8);
      //Left of head
      Minecraft.PlayerSkin.YzPlane(-32, -92, 92, 16, 8, 24, 16, 8);
      //Right of head
      Minecraft.PlayerSkin.yzPlane(32, -36, 92, 0, 8, 8, 16, 8);
      //Front of head
      Minecraft.PlayerSkin.xzPlane(28, -96, 92, 8, 8, 16, 16, 8);
      //Back of head
      Minecraft.PlayerSkin.XzPlane(-28, -32, 92, 24, 8, 32, 16, 8);
    popMatrix();
  }
}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "My_Little_Skin" });
  }
}
